=== modified file 'MANIFEST.in'
--- MANIFEST.in	2007-03-26 06:08:50 +0000
+++ MANIFEST.in	2006-12-24 06:43:14 +0000
@@ -1,4 +1,4 @@
-include dev.cfg loggerhead.conf.example README.txt NEWS
+include dev.cfg loggerhead.conf
 recursive-include loggerhead/templates *.kid
 recursive-include loggerhead/config *.cfg
 recursive-include loggerhead/static *

=== modified file 'Makefile'
--- Makefile	2007-10-29 16:19:30 +0000
+++ Makefile	2006-12-24 06:43:14 +0000
@@ -7,6 +7,3 @@
 clean:
 	rm -rf dist/
 
-check:
-	# XXX MichaelHudson 2007-10-29 bug=158361: We can't run the loggerhead
-	# tests in PQM yet :(

=== modified file 'NEWS'
--- NEWS	2008-03-06 01:59:26 +0000
+++ NEWS	2007-01-24 23:37:31 +0000
@@ -1,118 +1,12 @@
+
 What's changed in loggerhead?
 =============================
 
-1.2.1  [06mar2008]
-------------------
-
-    - The changelog view was out of order when not using the revision
-      cache.
-
-1.2  [04mar2008]
-----------------
-
-    - Michael Hudson <michael.hudson@canonical.com> has mostly taken
-      over the maintenance of loggerhead.
-
-    - loggerhead now has a simple test suite -- use 'nosetests' in the
-      loggerhead directory to run it.
-
-    - The rendering performance of pages that display large amounts of
-      text was improved by a factor of 4 or so.
-
-    - loggerhead no longer caches the text of the diffs between
-      revisions.  It rarely helped and wasted a lot of disk space.
-
-    - The layout of most pages was made more "tight" to waste less
-      screen real estate, and some other UI improvements (Kent
-      Gibson).
-
-    - Much dead code was removed.
-
-    - Loggerhead now computes the files changed between revisions only
-      when it needs to know this.  This is a fairly expensive
-      operation in Bazaar, and doing it less massively improves
-      performance and memory usage in some situations.
-
-    - Loggerhead now takes a read lock on the branch being viewed for
-      the duration of each request, which improves performance
-      significantly.
-
-    - Loggerhead no longer uses the corruption-prone Berkely DB-backed
-      shelve module for its caches, and rather (ab)uses a sqlite
-      database instead.
-
-    - The creation of History objects is much faster for large
-      branches (Aaron Bentley).
-
-    - Allow the construction of URLs using revnos and file paths as
-      well as revids and fileids (bug #98826):
-
-      - For changes pages, append the newest revno to display to the
-        URL, like http://.../changes/<revno>
-
-      - For annotate pages, append the revno to display to the URL,
-        followed by the path, like http://.../annotate/<revno>/<path>
-
-      - For file listing and revision pages append the revno to
-        display to the URL, like http://.../files/<revno>
-
-      Loggerhead still generates URLs using revision and file ids for
-      the moment.
-
-    - Many bugs were fixed:
-
-      - Loggerhead does not escape special characters when embedding a
-        revision ID in a URL (bug #88286)
-
-      - Improved robustness in the face of ghosts.
-
-      - Don't crash on displaying a commit with an empty message (bug
-        #86247)
-
-      - codebrowse fails with infinite redirections (James Henstridge,
-        bug #89854)
-
-      - Loggerhead fails to browse revisions that change binary files
-        (James Henstridge, bug #91686)
-
-      - Loggerhead atom feeds expose internal hostname (James
-        Henstridge, bug #93585)
-
-      - loggerhead don't like page break character (0x0C) in text
-        files (bug #113313)
-
-      - codebrowse source listings don't contain line number anchors
-        (bug #98826)
-
-      - only serve up unescaped user content with "Content-Disposition:
-        attachment"
-
-      - viewing the file listing consumes a lot memory (bug #116869)
-
-      - loggerhead can't handle empty branches (bug #119228)
-
-      - upgrading the format of a branch behind loggerhead could make
-        it fail for that branch (bug #118673)
-
-      - Error parsing non-ascii content (bug #117799)
-
-      - Loggerhead failed on whitespace-only commit messages.
-
-      - Links to diffs from within a revision do not work (bug
-        #119422)
-
-      - UTF-8 patches served as ISO-8859-1, fixed by served bundles as
-        application/octet-stream (bug #121336)
-
-      - TurboGears was turning query arguments into unicode, and bzr
-        stopped accepting unicode revids (bug #175228)
-
-
 1.1.1  [24jan2007]
 ------------------
 
     - fix broken inventory page (oops!)
-
+    
     - fix a few rendering problems with kid and safari
 
 
@@ -120,36 +14,35 @@
 ----------------
 
     - new feature to compare two revisions to each other
-
+    
     - inserted text in diffs is now blue instead of green
-
+    
     - fixed to start and stop as a daemon now (use "-f" to run in the
       foreground), and all config is in loggerhead.conf (no need to mess with
       dev.cfg)
-
+      
     - renamed show/hide javascript buttons to expand/collapse, and made them
       much faster
-
+      
     - added an atom-feed link to each branch on the browse page [elliot
       murphy]
-
+      
     - auto-publish feature for multiple branches under a single folder (see
       loggerhead.conf.example)
-
+      
     - added the ability to share cache files per-project instead of just
       per-branch
-
+    
     - added side-by-side diff display for the revision page (which is the
       default), with a button to switch between side-by-side and unified diff
       format
 
     - made caching use file locking, and close cleanly on shutdown
-
+    
     - miscellaneous speed and page-size improvements
 
 
-1.0  [23dec2006]
+1.0  [23dec2007]
 ----------------
 
     - initial release
-

=== modified file 'README.txt'
--- README.txt	2008-03-03 23:10:35 +0000
+++ README.txt	2007-01-24 19:29:58 +0000
@@ -1,83 +1,64 @@
 LOGGERHEAD
 ==========
 
-[ Version 1.2 for Bazaar 1.2 ]
-
-Loggerhead is a web viewer for Bazaar branches.  It can be used to
-navigate a branch history, annotate files, perform searches... all the
-usual things.
-
-To get started, first you need to create a 'loggerhead.conf' file
-specifying the branches you want to view.  A 'loggerhead.conf.example'
-file is included in the source which has comments explaining the
-various options.
-
-Loggerhead can then be started by running::
+[ version 1.1.1 for bazaar 0.13 ]
+
+Loggerhead is a web viewer for bazaar branches.  It can be used to navigate
+a branch history, annotate files, perform searches... all the usual things.
+
+This is a TurboGears (http://www.turbogears.org) project.  It can be
+started by running::
 
     $ ./start-loggerhead.py
-
-This will run loggerhead in the background.  It listens on port 8080
-by default, so go to http://localhost:8080/ in your browser to see the
-list of bublished branches.
-
-To stop Loggerhead, run::
+    
+This will run loggerhead in the background.  To stop it, run::
 
     $ ./stop-loggerhead.py
 
-If you want to view Bazaar branches from your existing Apache
-installation, you'll need to configure Apache to proxy certain
-requests to Loggerhead.  Adding lines like this to you Apache
-configuration is one way to do this::
+If you're not familiar with TurboGears, the simplest way to get running is
+to add the following lines to your apache configuration::
 
     <Location "/branches/">
         ProxyPass http://127.0.0.1:8080/
         ProxyPassReverse http://127.0.0.1:8080/
     </Location>
-
-In the configuration file you can configure projects, and branches per
-project.  The idea is that you could be publishing several (possibly
-unrelated) projects through the same loggerhead instance, and several
-branches for the same project.  See the "loggerhead.conf.example" file
-included with the source.
-
-Although Loggerhead is a TurboGears (http://www.turbogears.org)
-project, don't bother with "dev.cfg" or any of the other TurboGears
-config files.  Loggerhead overrides those values with its own.
-
-A debug and access log are stored in the logs/ folder, relative to
-the location of the start-loggerhead.py script.
-
-You may update the Bazaar branch at any time (for example, from a cron).
-Loggerhead will notice and refresh, and Bazaar uses its own branch
-locking to prevent corruption.
+    
+The config file is "loggerhead.conf".  In there, you can configure projects,
+and branches per project.  The idea is that you could be publishing several
+(possibly unrelated) projects through the same loggerhead instance, and 
+several branches for the same project.
+
+Don't bother with "dev.cfg" or any of the other TurboGears config files.
+Loggerhead overrides those values with its own.
+
+A debug and access log are stored in the logs/ folder.
 
 
 CACHES
 ------
 
-To speed up operations with large branches, loggerhead can be configured
-to create three caches per branch when it first launches:
+To speed up most operations, loggerhead will start creating two caches per
+branch when it first launches:
 
     - a revision data cache
-    - a cache of files changed in a revision
     - a text searching cache
 
-You can put the cache folder anywhere.
-
-The revision data cache and text searching cache will be automatically
-filled once loggerhead starts up.  The caches for a branch with 15,000
-revisions take about four minutes each on a fairly fast machine, but
-mileage may vary.  Once they are built, they update every six hours or
-so but usually finish quickly (or instantly) after the initial creation.
+You can put the cache folder anywhere, but I find that a folder under
+the branch's .bzr/ folder is the simplest place.
+
+The caches for a branch with 10,000 revisions take about 15 minutes each
+on my machine, but YMMV.  Once they are built, they update every six hours
+or so but usually finish quickly (or instantly) after the initial creation.
+Until the revision cache is built, all operations will be slow.
+
+You may update the bazaar branch at any time (for example, from a cron).
+Loggerhead will notice and refresh, and bazaar uses its own branch locking
+to prevent corruption.
 
 
 SUPPORT
 -------
 
-Loggerhead is loosely based on bazaar-webserve, which was loosely
-based on hgweb.  Discussion should take place on the bazaar-dev
-mailing list at bazaar@lists.canonical.com.  You can join the list at
-<https://lists.ubuntu.com/mailman/listinfo/bazaar>.  You don't need to
-subscribe to post, but your first post will be held briefly for manual
-moderation.
+This is loosely based on bazaar-webserve, which was loosely based on hgweb.
+Discussion should take place on the bazaar-dev mailing list.
 

=== modified file 'dev.cfg'
--- dev.cfg	2007-12-12 08:36:51 +0000
+++ dev.cfg	2007-01-14 05:40:40 +0000
@@ -36,10 +36,6 @@
 server.environment="production"
 #autoreload.package="loggerhead"
 
-# We do *not* want our query arguments turned into unicode strings (as
-# we use them for revision/file ids, and these must not be unicode).
-decoding_filter.on = False
-
 # session_filter.on = True
 
 # Set to True if you'd like to abort execution if a controller gets an

=== modified file 'loggerhead.conf.example'
--- loggerhead.conf.example	2007-06-18 23:07:53 +0000
+++ loggerhead.conf.example	2007-01-14 05:40:40 +0000
@@ -12,9 +12,6 @@
 # if you want a special title on the front page, set it here:
 title = 'branches in loggerhead'
 
-# the access and debug logs can be set up to roll 'daily', 'weekly', or 'never':
-log.roll = 'weekly'
-
 # group branches by project:
 [bazaar]
 

=== modified file 'loggerhead/TODO'
--- loggerhead/TODO	2007-05-21 06:19:31 +0000
+++ loggerhead/TODO	2007-01-21 02:46:53 +0000
@@ -6,15 +6,11 @@
 
 * potentially do a 'bzr pull' on a branch on an interval timer
 
+* maybe change "changes" to "history"?  -- asked on bazaar-dev@ for opinions.
+    -- nobody seems to care.
+
 * browse view: sort by name, last change?
 
 * something is leaking on www.lag.net/branches
 
 * download tar archive of revision?
-
-* nicholas allen suggested the ability to change the # of context lines
-  in diffs (probably something inside bzrlib) and also the ability to see
-  an entire file in diff format
-
-* setup.py install doesn't work
-

=== modified file 'loggerhead/branchview.py'
--- loggerhead/branchview.py	2008-02-27 03:36:09 +0000
+++ loggerhead/branchview.py	2007-03-06 04:27:05 +0000
@@ -29,7 +29,7 @@
 from cherrypy import HTTPRedirect
 
 from loggerhead import util
-from loggerhead.changecache import ChangeCache, FileChangeCache
+from loggerhead.changecache import ChangeCache
 from loggerhead.history import History
 from loggerhead.textindex import TextIndex
 from loggerhead.controllers.changelog_ui import ChangeLogUI
@@ -53,12 +53,12 @@
         self._config = config
         self._project_config = project_config
         self.log = logging.getLogger('loggerhead.%s' % (name,))
-
+        
         # branch history
         self._history_lock = threading.RLock()
         self._history = None
         self._closed = False
-
+        
         self.changes = ChangeLogUI(self)
         self.revision = RevisionUI(self)
         self.files = InventoryUI(self)
@@ -66,12 +66,12 @@
         self.download = DownloadUI(self)
         self.atom = AtomUI(self)
         self.bundle = BundleUI(self)
-
+        
         # force history object to be loaded:
         self.get_history()
-
+        
         turbogears.startup.call_on_shutdown.append(self.close)
-
+    
     @with_history_lock
     def close(self):
         # it's important that we cleanly detach the history, so the cache
@@ -80,13 +80,13 @@
         self._history.detach()
         self._history = None
         self._closed = True
-
+            
     config = property(lambda self: self._config)
-
+    
     name = property(lambda self: self._name)
 
     group_name = property(lambda self: self._group_name)
-
+    
     def _get_friendly_name(self):
         name = self._config.get('branch_name', None)
         if name is not None:
@@ -106,9 +106,9 @@
         # try branch-specific config?
         description = self.get_history().get_config().get_user_option('description')
         return description
-
+        
     description = property(_get_description)
-
+    
     def _get_branch_url(self):
         url = self._config.get('url', None)
         if url is not None:
@@ -120,9 +120,9 @@
         # try branch-specific config?
         url = self.get_history().get_config().get_user_option('public_branch')
         return url
-
+        
     branch_url = property(_get_branch_url)
-
+    
     @turbogears.expose()
     def index(self):
         raise HTTPRedirect(self.url('/changes'))
@@ -141,25 +141,22 @@
             self.log.debug('Reload branch history...')
             if self._history is not None:
                 self._history.detach()
-            _history = self._history = History.from_folder(
-                self._absfolder, self._name)
+            self._history = History.from_folder(self._absfolder, self._name)
             cache_path = self._config.get('cachepath', None)
             if cache_path is None:
                 # try the project config
                 cache_path = self._project_config.get('cachepath', None)
             if cache_path is not None:
-                _history.use_cache(ChangeCache(_history, cache_path))
-                _history.use_file_cache(FileChangeCache(_history, cache_path))
-                _history.use_search_index(TextIndex(_history, cache_path))
+                self._history.use_cache(ChangeCache(self._history, cache_path))
+                self._history.use_search_index(TextIndex(self._history, cache_path))
         return self._history
-
+    
     def check_rebuild(self):
         h = self.get_history()
         if h is not None:
             h.check_rebuild()
-
+    
     def url(self, elements, **kw):
-        "build an url relative to this branch"
         if not isinstance(elements, list):
             elements = [elements]
         if elements[0].startswith('/'):
@@ -167,10 +164,6 @@
         elements = [urllib.quote(x) for x in elements]
         return turbogears.url([ '/' + self.group_name, self.name ] + elements, **kw)
 
-    def context_url(self, elements, **kw):
-        "build an url relative to this branch, bringing along browsing context"
-        return self.url(elements, **util.get_context(**kw))
-
     def last_updated(self):
         h = self.get_history()
         change = h.get_changes([ h.last_revid ])[0]

=== modified file 'loggerhead/changecache.py'
--- loggerhead/changecache.py	2008-02-27 03:36:09 +0000
+++ loggerhead/changecache.py	2007-01-08 00:00:26 +0000
@@ -25,109 +25,48 @@
 cached a change, it's good forever.
 """
 
-import cPickle
+import logging
 import os
+import shelve
+import threading
 import time
 
 from loggerhead import util
+from loggerhead.util import decorator
 from loggerhead.lockfile import LockFile
 
 
 with_lock = util.with_lock('_lock', 'ChangeCache')
-
-SQLITE_INTERFACE = os.environ.get('SQLITE_INTERFACE', 'sqlite')
-
-if SQLITE_INTERFACE == 'pysqlite2':
-    from pysqlite2 import dbapi2
-    _param_marker = '?'
-elif SQLITE_INTERFACE == 'sqlite':
-    import sqlite as dbapi2
-    _param_marker = '%s'
-else:
-    raise AssertionError("bad sqlite interface %r!?"%SQLITE_INTERFACE)
-
-_select_stmt = ("select data from revisiondata where revid = ?"
-                ).replace('?', _param_marker)
-_insert_stmt = ("insert into revisiondata (revid, data) "
-                "values (?, ?)").replace('?', _param_marker)
-_update_stmt = ("update revisiondata set data = ? where revid = ?"
-                ).replace('?', _param_marker)
-
-
-
-
-class FakeShelf(object):
-    def __init__(self, filename):
-        create_table = not os.path.exists(filename)
-        self.connection = dbapi2.connect(filename)
-        self.cursor = self.connection.cursor()
-        if create_table:
-            self._create_table()
-    def _create_table(self):
-        self.cursor.execute(
-            "create table RevisionData "
-            "(revid binary primary key, data binary)")
-        self.connection.commit()
-    def _serialize(self, obj):
-        r = dbapi2.Binary(cPickle.dumps(obj, protocol=2))
-        return r
-    def _unserialize(self, data):
-        return cPickle.loads(str(data))
-    def get(self, revid):
-        self.cursor.execute(_select_stmt, (revid,))
-        filechange = self.cursor.fetchone()
-        if filechange is None:
-            return None
-        else:
-            return self._unserialize(filechange[0])
-    def add(self, revid_obj_pairs, commit=True):
-        for  (r, d) in revid_obj_pairs:
-            self.cursor.execute(_insert_stmt, (r, self._serialize(d)))
-        if commit:
-            self.connection.commit()
-    def update(self, revid_obj_pairs, commit=True):
-        for  (r, d) in revid_obj_pairs:
-            self.cursor.execute(_update_stmt, (self._serialize(d), r))
-        if commit:
-            self.connection.commit()
-    def count(self):
-        self.cursor.execute(
-            "select count(*) from revisiondata")
-        return self.cursor.fetchone()[0]
-    def close(self, commit=False):
-        if commit:
-            self.connection.commit()
-        self.connection.close()
+        
 
 class ChangeCache (object):
-
+    
     def __init__(self, history, cache_path):
         self.history = history
         self.log = history.log
-
+        
         if not os.path.exists(cache_path):
             os.mkdir(cache_path)
 
-        self._changes_filename = os.path.join(cache_path, 'changes.sql')
-
+        # keep a separate cache for the diffs, because they're very time-consuming to fetch.
+        self._changes_filename = os.path.join(cache_path, 'changes')
+        self._changes_diffs_filename = os.path.join(cache_path, 'changes-diffs')
+        
         # use a lockfile since the cache folder could be shared across different processes.
         self._lock = LockFile(os.path.join(cache_path, 'lock'))
         self._closed = False
-
-##         # this is fluff; don't slow down startup time with it.
-##         # but it is racy in tests :(
-##         def log_sizes():
-##             self.log.info('Using change cache %s; %d entries.' % (cache_path, self.size()))
-##         threading.Thread(target=log_sizes).start()
-
-    def _cache(self):
-        return FakeShelf(self._changes_filename)
-
+        
+        # this is fluff; don't slow down startup time with it.
+        def log_sizes():
+            s1, s2 = self.sizes()
+            self.log.info('Using change cache %s; %d/%d entries.' % (cache_path, s1, s2))
+        threading.Thread(target=log_sizes).start()
+    
     @with_lock
     def close(self):
         self.log.debug('Closing cache file.')
         self._closed = True
-
+    
     @with_lock
     def closed(self):
         return self._closed
@@ -135,51 +74,67 @@
     @with_lock
     def flush(self):
         pass
-
+    
     @with_lock
-    def get_changes(self, revid_list):
+    def get_changes(self, revid_list, get_diffs=False):
         """
         get a list of changes by their revision_ids.  any changes missing
         from the cache are fetched by calling L{History.get_change_uncached}
         and inserted into the cache before returning.
         """
+        if get_diffs:
+            cache = shelve.open(self._changes_diffs_filename, 'c', protocol=2)
+        else:
+            cache = shelve.open(self._changes_filename, 'c', protocol=2)
+
         out = []
-        missing_revids = []
-        missing_revid_indices = []
-        cache = self._cache()
+        fetch_list = []
+        sfetch_list = []
         for revid in revid_list:
-            entry = cache.get(revid)
-            if entry is not None:
-                out.append(entry)
+            # if the revid is in unicode, use the utf-8 encoding as the key
+            srevid = util.to_utf8(revid)
+            
+            if srevid in cache:
+                out.append(cache[srevid])
             else:
-                missing_revids.append(revid)
-                missing_revid_indices.append(len(out))
+                #self.log.debug('Entry cache miss: %r' % (revid,))
                 out.append(None)
-        if missing_revids:
-            missing_entries = self.history.get_changes_uncached(missing_revids)
-            missing_entry_dict = {}
-            for entry in missing_entries:
-                missing_entry_dict[entry.revid] = entry
-            revid_entry_pairs = []
-            for i, revid in zip(missing_revid_indices, missing_revids):
-                out[i] = entry = missing_entry_dict.get(revid)
-                if entry is not None:
-                    revid_entry_pairs.append((revid, entry))
-            cache.add(revid_entry_pairs)
-        return filter(None, out)
-
-    @with_lock
-    def full(self):
-        cache = self._cache()
-        last_revid = util.to_utf8(self.history.last_revid)
-        revision_history = self.history.get_revision_history()
-        return (cache.count() >= len(revision_history)
-                and cache.get(last_revid) is not None)
-
-    @with_lock
-    def size(self):
-        return self._cache().count()
-
+                fetch_list.append(revid)
+                sfetch_list.append(srevid)
+        
+        if len(fetch_list) > 0:
+            # some revisions weren't in the cache; fetch them
+            changes = self.history.get_changes_uncached(fetch_list, get_diffs)
+            if changes is None:
+                return changes
+            for i in xrange(len(revid_list)):
+                if out[i] is None:
+                    cache[sfetch_list.pop(0)] = out[i] = changes.pop(0)
+        
+        cache.close()
+        return out
+    
+    @with_lock
+    def full(self, get_diffs=False):
+        if get_diffs:
+            cache = shelve.open(self._changes_diffs_filename, 'c', protocol=2)
+        else:
+            cache = shelve.open(self._changes_filename, 'c', protocol=2)
+        try:
+            return (len(cache) >= len(self.history.get_revision_history())) and (util.to_utf8(self.history.last_revid) in cache)
+        finally:
+            cache.close()
+
+    @with_lock
+    def sizes(self):
+        cache = shelve.open(self._changes_filename, 'c', protocol=2)
+        s1 = len(cache)
+        cache.close()
+        cache = shelve.open(self._changes_diffs_filename, 'c', protocol=2)
+        s2 = len(cache)
+        cache.close()
+        return s1, s2
+        
     def check_rebuild(self, max_time=3600):
         """
         check if we need to fill in any missing pieces of the cache.  pull in
@@ -188,7 +143,7 @@
         """
         if self.closed() or self.full():
             return
-
+        
         self.log.info('Building revision cache...')
         start_time = time.time()
         last_update = time.time()
@@ -218,39 +173,4 @@
         self.log.info('Revision cache rebuild completed.')
         self.flush()
 
-class FileChangeCache(object):
-    def __init__(self, history, cache_path):
-        self.history = history
-
-        if not os.path.exists(cache_path):
-            os.mkdir(cache_path)
-
-        self._changes_filename = os.path.join(cache_path, 'filechanges.sql')
-
-        # use a lockfile since the cache folder could be shared across
-        # different processes.
-        self._lock = LockFile(os.path.join(cache_path, 'filechange-lock'))
-
-    @with_lock
-    def get_file_changes(self, entries):
-        out = []
-        missing_entries = []
-        missing_entry_indices = []
-        cache = FakeShelf(self._changes_filename)
-        for entry in entries:
-            changes = cache.get(entry.revid)
-            if changes is not None:
-                out.append(changes)
-            else:
-                missing_entries.append(entry)
-                missing_entry_indices.append(len(out))
-                out.append(None)
-        if missing_entries:
-            missing_changes = self.history.get_file_changes_uncached(missing_entries)
-            revid_changes_pairs = []
-            for i, entry, changes in zip(
-                missing_entry_indices, missing_entries, missing_changes):
-                revid_changes_pairs.append((entry.revid, changes))
-                out[i] = changes
-            cache.add(revid_changes_pairs)
-        return out
+

=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2008-02-27 03:35:24 +0000
+++ loggerhead/controllers/__init__.py	2007-01-14 05:40:40 +0000
@@ -20,14 +20,17 @@
 import logging
 import os
 import re
+import sys
+import time
 
 import turbogears
 from turbogears import controllers
+from cherrypy import HTTPRedirect, NotFound
 from configobj import ConfigObj
 
 from loggerhead import util
 from loggerhead.branchview import BranchView
-from loggerhead.history import is_branch
+from loggerhead.history import History, is_branch
 
 log = logging.getLogger("loggerhead.controllers")
 
@@ -49,38 +52,24 @@
         
         self._views = []
         for view_name in config.sections:
-            log.debug('Configuring (project %s) branch %s...', name, view_name)
+            log.debug('Configuring (project %r) branch %r...', name, view_name)
             self._add_view(view_name, config[view_name], config[view_name].get('folder'))
         
-        self._auto_folder = config.get('auto_publish_folder', None)
-        self._auto_list = []
-        if self._auto_folder is not None:
-            self._recheck_auto_folders()
+        auto_folder = config.get('auto_publish_folder', None)
+        if auto_folder is not None:
+            auto_list = []
+            # scan a folder for bazaar branches, and add them automatically
+            for path, folders, filenames in os.walk(auto_folder):
+                for folder in folders:
+                    folder = os.path.join(path, folder)
+                    if is_branch(folder):
+                        auto_list.append(folder)
+            auto_list.sort()
+            for folder in auto_list:
+                view_name = os.path.basename(folder)
+                log.debug('Auto-configuring (project %r) branch %r...', name, view_name)
+                self._add_view(view_name, ConfigObj(), folder)
     
-    def _recheck_auto_folders(self):
-        if self._auto_folder is None:
-            return
-        auto_list = []
-        # scan a folder for bazaar branches, and add them automatically
-        for path, folders, filenames in os.walk(self._auto_folder):
-            for folder in folders:
-                folder = os.path.join(path, folder)
-                if is_branch(folder):
-                    auto_list.append(folder)
-        auto_list.sort()
-        if auto_list == self._auto_list:
-            # nothing has changed; do nothing.
-            return
-
-        # rebuild views:
-        log.debug('Rescanning auto-folder for project %s ...', self.name)
-        self._views = []
-        for folder in auto_list:
-            view_name = os.path.basename(folder)
-            log.debug('Auto-configuring (project %s) branch %s...', self.name, view_name)
-            self._add_view(view_name, ConfigObj(), folder)
-        self._auto_list = auto_list
-        
     def _add_view(self, view_name, view_config, folder):
         c_view_name = cherrypy_friendly(view_name)
         view = BranchView(self.name, c_view_name, view_name, folder, view_config, self._config)
@@ -91,23 +80,20 @@
 
 
 class Root (controllers.RootController):
-    def __init__(self, config):
+    def __init__(self):
         self._projects = []
-        self._config = config
-        for project_name in self._config.sections:
+        for project_name in sys._loggerhead_config.sections:
             c_project_name = cherrypy_friendly(project_name)
-            project = Project(c_project_name, self._config[project_name])
+            project = Project(c_project_name, sys._loggerhead_config[project_name])
             self._projects.append(project)
             setattr(self, c_project_name, project)
         
     @turbogears.expose(template='loggerhead.templates.browse')
     def index(self):
-        for p in self._projects:
-            p._recheck_auto_folders()
         return {
             'projects': self._projects,
             'util': util,
-            'title': self._config.get('title', ''),
+            'title': sys._loggerhead_config.get('title', ''),
         }
 
     def _check_rebuild(self):
@@ -116,6 +102,9 @@
                 v.check_rebuild()
 
 
+# singleton:
+Root = Root()
+
 
 # for use in profiling the very-slow get_change() method:
 #h = Root.bazaar.bzr_dev.get_history()

=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2008-02-27 03:35:24 +0000
+++ loggerhead/controllers/annotate_ui.py	2007-01-21 00:05:52 +0000
@@ -17,13 +17,15 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import datetime
 import logging
 import os
 import posixpath
+import textwrap
 import time
 
 import turbogears
-from cherrypy import HTTPError
+from cherrypy import HTTPRedirect, session
 
 from loggerhead import util
 
@@ -50,48 +52,41 @@
         z = time.time()
         h = self._branch.get_history()
         util.set_context(kw)
+        
+        if len(args) > 0:
+            revid = h.fix_revid(args[0])
+        else:
+            revid = None
+        
+        file_id = kw.get('file_id', None)
+        if file_id is None:
+            raise HTTPRedirect(self._branch.url('/changes'))
 
-        h._branch.lock_read()
         try:
-            if len(args) > 0:
-                revid = h.fix_revid(args[0])
-            else:
-                revid = h.last_revid
-
-            path = None
-            if len(args) > 1:
-                path = '/'.join(args[1:])
-                if not path.startswith('/'):
-                    path = '/' + path
-
-            file_id = kw.get('file_id', None)
-            if (file_id is None) and (path is None):
-                raise HTTPError(400, 'No file_id or filename provided to annotate')
-
-            if file_id is None:
-                file_id = h.get_file_id(revid, path)
-
-            # no navbar for revisions
-            navigation = util.Container()
-
-            if path is None:
-                path = h.get_path(revid, file_id)
-            filename = os.path.basename(path)
-
-            vals = {
-                'branch': self._branch,
-                'util': util,
-                'revid': revid,
-                'file_id': file_id,
-                'path': path,
-                'filename': filename,
-                'history': h,
-                'navigation': navigation,
-                'change': h.get_changes([ revid ])[0],
-                'contents': list(h.annotate_file(file_id, revid)),
-            }
-            h.flush_cache()
-            self.log.info('/annotate: %r secs' % (time.time() - z,))
-            return vals
-        finally:
-            h._branch.unlock()
+            revid_list, revid = h.get_file_view(revid, file_id)
+        except Exception, x:
+            self.log.error('Exception fetching changes: %s' % (x,))
+            util.log_exception(self.log)
+            raise HTTPRedirect(self._branch.url('/changes'))
+            
+        # no navbar for revisions
+        navigation = util.Container()
+        
+        path = h.get_path(revid, file_id)
+        filename = os.path.basename(path)
+
+        vals = {
+            'branch': self._branch,
+            'util': util,
+            'revid': revid,
+            'file_id': file_id,
+            'path': path,
+            'filename': filename,
+            'history': h,
+            'navigation': navigation,
+            'change': h.get_changes([ revid ])[0],
+            'contents': list(h.annotate_file(file_id, revid)),
+        }
+        h.flush_cache()
+        self.log.info('/annotate: %r secs' % (time.time() - z,))
+        return vals

=== modified file 'loggerhead/controllers/atom_ui.py'
--- loggerhead/controllers/atom_ui.py	2008-02-27 03:35:24 +0000
+++ loggerhead/controllers/atom_ui.py	2006-12-20 21:17:53 +0000
@@ -17,6 +17,7 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import cherrypy
 import turbogears
 
 from loggerhead import util
@@ -32,22 +33,19 @@
     @turbogears.expose(template='loggerhead.templates.atom', format="xml", content_type="application/atom+xml")
     def default(self, *args):
         h = self._branch.get_history()
-
-        h._branch.lock_read()
-        try:
-            pagesize = int(self._branch.config.get('pagesize', '20'))
-
-            revid_list = h.get_file_view(h.last_revid, None)
-            entries = list(h.get_changes(list(revid_list)[:pagesize]))
-
-            vals = {
-                'branch': self._branch,
-                'changes': entries,
-                'util': util,
-                'history': h,
-                'updated': entries[0].date.isoformat() + 'Z',
-            }
-            h.flush_cache()
-            return vals
-        finally:
-            h._branch.unlock()
+        pagesize = int(self._branch.config.get('pagesize', '20'))
+
+        revid_list, start_revid = h.get_file_view(None, None)
+        entries = list(h.get_changes(list(revid_list)[:pagesize]))
+
+        vals = {
+            'external_url': cherrypy.request.base,
+            'branch': self._branch,
+            'changes': entries,
+            'util': util,
+            'history': h,
+            'scan_url': '/changes',
+            'updated': entries[0].date.isoformat() + 'Z',
+        }
+        h.flush_cache()
+        return vals

=== modified file 'loggerhead/controllers/bundle_ui.py'
--- loggerhead/controllers/bundle_ui.py	2008-02-27 03:35:24 +0000
+++ loggerhead/controllers/bundle_ui.py	2007-01-21 00:05:52 +0000
@@ -16,10 +16,13 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import os
 import time
 
 import turbogears
-from cherrypy import HTTPRedirect, InternalError, response
+from cherrypy import HTTPRedirect, response
+
+from loggerhead import util
 
 
 class BundleUI (object):
@@ -31,30 +34,27 @@
 
     @turbogears.expose()
     def default(self, *args, **kw):
-        # /bundle/<rev_id>/[<compare_rev_id>/]filename
+        # /bundle/<rev_id>/filename
         z = time.time()
         h = self._branch.get_history()
-
-        h._branch.lock_read()
+        compare_revid = kw.get('compare_revid', None)
+
+        if len(args) < 1:
+            raise HTTPRedirect(self._branch.url('/changes'))
+        revid = h.fix_revid(args[0])
+        compare_revid = None
+        if len(args) >= 3:
+            compare_revid = h.fix_revid(args[1])
+
         try:
-            if len(args) < 1:
-                raise HTTPRedirect(self._branch.url('/changes'))
-            revid = h.fix_revid(args[0])
-            if len(args) >= 3:
-                compare_revid = h.fix_revid(args[1])
-            else:
-                compare_revid = None
-
-            try:
-                bundle_data = h.get_bundle(revid, compare_revid)
-            except:
-                self.log.exception('Exception fetching bundle')
-                raise InternalError('Could not fetch bundle')
-
-            response.headers['Content-Type'] = 'application/octet-stream'
-            response.headers['Content-Length'] = len(bundle_data)
-            response.body = bundle_data
-            self.log.info('/bundle: %r seconds' % (time.time() - z,))
-            return response.body
-        finally:
-            h._branch.unlock()
+            bundle_data = h.get_bundle(revid, compare_revid)
+        except Exception, x:
+            self.log.error('Exception fetching bundle: %s' % (x,))
+            util.log_exception(self.log)
+            raise HTTPRedirect(self._branch.url('/changes'))
+            
+        response.headers['Content-Type'] = 'text/plain'
+        response.headers['Content-Length'] = len(bundle_data)
+        response.body = bundle_data
+        self.log.info('/bundle: %r seconds' % (time.time() - z,))
+        return response.body

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2008-02-27 03:35:24 +0000
+++ loggerhead/controllers/changelog_ui.py	2007-01-21 00:05:52 +0000
@@ -17,14 +17,17 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import os
 import time
 
 import turbogears
-from cherrypy import InternalError
+from cherrypy import HTTPRedirect, session
 
 from loggerhead import util
 
 
+
+
 class ChangeLogUI (object):
     
     def __init__(self, branch):
@@ -38,81 +41,61 @@
         z = time.time()
         h = self._branch.get_history()
         config = self._branch.config
+        
+        if len(args) > 0:
+            revid = h.fix_revid(args[0])
+        else:
+            revid = None
 
-        h._branch.lock_read()
+        file_id = kw.get('file_id', None)
+        query = kw.get('q', None)
+        start_revid = h.fix_revid(kw.get('start_revid', None))
+        orig_start_revid = start_revid
+        pagesize = int(config.get('pagesize', '20'))
+        search_failed = False
+        
         try:
-            if len(args) > 0:
-                revid = h.fix_revid(args[0])
+            revid, start_revid, revid_list = h.get_view(revid, start_revid, file_id, query)
+            kw['start_revid'] = start_revid
+            util.set_context(kw)
+            
+            if (query is not None) and (len(revid_list) == 0):
+                search_failed = True
+
+            if len(revid_list) == 0:
+                scan_list = revid_list
             else:
-                revid = None
-
-            file_id = kw.get('file_id', None)
-            query = kw.get('q', None)
-            start_revid = h.fix_revid(kw.get('start_revid', None))
-            orig_start_revid = start_revid
-            pagesize = int(config.get('pagesize', '20'))
-            search_failed = False
-
-            try:
-                revid, start_revid, revid_list = h.get_view(revid, start_revid, file_id, query)
-                kw['start_revid'] = start_revid
-                util.set_context(kw)
-
-                if (query is not None) and (len(revid_list) == 0):
-                    search_failed = True
-
-                if len(revid_list) == 0:
-                    scan_list = revid_list
-                else:
-                    if revid in revid_list: # XXX is this always true?
-                        i = revid_list.index(revid)
-                    else:
-                        i = None
-                    scan_list = revid_list[i:]
-                change_list = scan_list[:pagesize]
-                changes = list(h.get_changes(change_list))
-                h.add_changes(changes)
-            except:
-                self.log.exception('Exception fetching changes')
-                raise InternalError('Could not fetch changes')
-
-            navigation = util.Container(pagesize=pagesize, revid=revid, start_revid=start_revid, revid_list=revid_list,
-                                        file_id=file_id, scan_url='/changes', branch=self._branch, feed=True)
-            if query is not None:
-                navigation.query = query
-            util.fill_in_navigation(navigation)
-
-            # add parent & merge-point branch-nick info, in case it's useful
-            h.get_branch_nicks(changes)
-
-            # does every change on this page have the same committer?  if so,
-            # tell the template to show committer info in the "details block"
-            # instead of on each line.
-            all_same_author = True
-
-            if changes:
-                author = changes[0].author
-                for e in changes[1:]:
-                    if e.author != author:
-                        all_same_author = False
-                        break
-
-            vals = {
-                'branch': self._branch,
-                'changes': changes,
-                'util': util,
-                'history': h,
-                'revid': revid,
-                'navigation': navigation,
-                'file_id': file_id,
-                'start_revid': start_revid,
-                'viewing_from': (orig_start_revid is not None) and (orig_start_revid != h.last_revid),
-                'query': query,
-                'search_failed': search_failed,
-                'all_same_author': all_same_author,
-            }
-            h.flush_cache()
-            self.log.info('/changes %r: %r secs' % (revid, time.time() - z))
-            return vals
-        finally:
-            h._branch.unlock()
+                scan_list = revid_list[h.get_revid_sequence(revid_list, revid):]
+            entry_list = scan_list[:pagesize]
+            entries = h.get_changes(entry_list)
+        except Exception, x:
+            self.log.error('Exception fetching changes: %s' % (x,))
+            util.log_exception(self.log)
+            raise HTTPRedirect(self._branch.url('/changes'))
+
+        navigation = util.Container(pagesize=pagesize, revid=revid, start_revid=start_revid, revid_list=revid_list,
+                                    file_id=file_id, scan_url='/changes', branch=self._branch, feed=True)
+        if query is not None:
+            navigation.query = query
+        util.fill_in_navigation(h, navigation)
+        
+        entries = list(entries)
+        # add parent & merge-point branch-nick info, in case it's useful
+        h.get_branch_nicks(entries)
+
+        vals = {
+            'branch': self._branch,
+            'changes': list(entries),
+            'util': util,
+            'history': h,
+            'revid': revid,
+            'navigation': navigation,
+            'file_id': file_id,
+            'start_revid': start_revid,
+            'viewing_from': (orig_start_revid is not None) and (orig_start_revid != h.last_revid),
+            'query': query,
+            'search_failed': search_failed,
+        }
+        h.flush_cache()
+        self.log.info('/changes %r: %r secs' % (revid, time.time() - z))
+        return vals

=== modified file 'loggerhead/controllers/download_ui.py'
--- loggerhead/controllers/download_ui.py	2008-02-27 03:35:24 +0000
+++ loggerhead/controllers/download_ui.py	2007-01-24 19:26:27 +0000
@@ -17,12 +17,18 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import datetime
 import logging
 import mimetypes
+import os
+import posixpath
+import textwrap
 import time
 
 import turbogears
-from cherrypy import HTTPRedirect, response
+from cherrypy import HTTPRedirect, response, session
+
+from loggerhead import util
 
 
 log = logging.getLogger("loggerhead.controllers")
@@ -41,23 +47,18 @@
         z = time.time()
         h = self._branch.get_history()
         
-        h._branch.lock_read()
-        try:
-            if len(args) < 2:
-                raise HTTPRedirect(self._branch.url('/changes'))
-
-            revid = h.fix_revid(args[0])
-            file_id = args[1]
-            path, filename, content = h.get_file(file_id, revid)
-            mime_type, encoding = mimetypes.guess_type(filename)
-            if mime_type is None:
-                mime_type = 'application/octet-stream'
-
-            self.log.info('/download %s @ %s (%d bytes)', path, h.get_revno(revid), len(content))
-            response.headers['Content-Type'] = mime_type
-            response.headers['Content-Length'] = len(content)
-            response.headers['Content-Disposition'] = 'attachment; filename=%s'%(filename,)
-            response.body = content
-            return response.body
-        finally:
-            h._branch.unlock()
+        if len(args) < 2:
+            raise HTTPRedirect(self._branch.url('/changes'))
+        
+        revid = h.fix_revid(args[0])
+        file_id = args[1]
+        path, filename, content = h.get_file(file_id, revid)
+        mime_type, encoding = mimetypes.guess_type(filename)
+        if mime_type is None:
+            mime_type = 'application/octet-stream'
+
+        self.log.info('/download %s @ %s (%d bytes)', path, h.get_revno(revid), len(content))
+        response.headers['Content-Type'] = mime_type
+        response.headers['Content-Length'] = len(content)
+        response.body = content
+        return response.body

=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2008-02-27 03:35:24 +0000
+++ loggerhead/controllers/inventory_ui.py	2007-01-21 00:05:52 +0000
@@ -17,12 +17,15 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import datetime
 import logging
+import os
 import posixpath
+import textwrap
 import time
 
 import turbogears
-from cherrypy import InternalError
+from cherrypy import HTTPRedirect, session
 
 from loggerhead import util
 
@@ -49,59 +52,58 @@
         z = time.time()
         h = self._branch.get_history()
         util.set_context(kw)
+        
+        if len(args) > 0:
+            revid = h.fix_revid(args[0])
+        else:
+            revid = None
+        
+        file_id = kw.get('file_id', None)
+        sort_type = kw.get('sort', None)
 
-        h._branch.lock_read()
         try:
-            if len(args) > 0:
-                revid = h.fix_revid(args[0])
-            else:
-                revid = h.last_revid
-
-            try:
-                inv = h.get_inventory(revid)
-            except:
-                self.log.exception('Exception fetching changes')
-                raise InternalError('Could not fetch changes')
-
-            file_id = kw.get('file_id', inv.root.file_id)
-            sort_type = kw.get('sort', None)
-
-            # no navbar for revisions
-            navigation = util.Container()
-
-            change = h.get_changes([ revid ])[0]
-            # add parent & merge-point branch-nick info, in case it's useful
-            h.get_branch_nicks([ change ])
-
-            path = inv.id2path(file_id)
-            if not path.startswith('/'):
-                path = '/' + path
-            idpath = inv.get_idpath(file_id)
-            if len(idpath) > 1:
-                updir = dirname(path)
-                updir_file_id = idpath[-2]
-            else:
-                updir = None
-                updir_file_id = None
-            if updir == '/':
-                updir_file_id = None
-
-            vals = {
-                'branch': self._branch,
-                'util': util,
-                'revid': revid,
-                'change': change,
-                'file_id': file_id,
-                'path': path,
-                'updir': updir,
-                'updir_file_id': updir_file_id,
-                'filelist': h.get_filelist(inv, file_id, sort_type),
-                'history': h,
-                'posixpath': posixpath,
-                'navigation': navigation,
-            }
-            h.flush_cache()
-            self.log.info('/inventory %r: %r secs' % (revid, time.time() - z))
-            return vals
-        finally:
-            h._branch.unlock()
+            revid_list, revid = h.get_file_view(revid, file_id)
+            rev = h.get_revision(revid)
+            inv = h.get_inventory(revid)
+        except Exception, x:
+            self.log.error('Exception fetching changes: %s' % (x,))
+            util.log_exception(self.log)
+            raise HTTPRedirect(self._branch.url('/changes'))
+
+        # no navbar for revisions
+        navigation = util.Container()
+
+        change = h.get_changes([ revid ])[0]
+        # add parent & merge-point branch-nick info, in case it's useful
+        h.get_branch_nicks([ change ])
+        
+        path = inv.id2path(file_id)
+        if not path.startswith('/'):
+            path = '/' + path
+        idpath = inv.get_idpath(file_id)
+        if len(idpath) > 1:
+            updir = dirname(path)
+            updir_file_id = idpath[-2]
+        else:
+            updir = None
+            updir_file_id = None
+        if updir == '/':
+            updir_file_id = None
+
+        vals = {
+            'branch': self._branch,
+            'util': util,
+            'revid': revid,
+            'change': change,
+            'file_id': file_id,
+            'path': path,
+            'updir': updir,
+            'updir_file_id': updir_file_id,
+            'filelist': h.get_filelist(inv, path, sort_type),
+            'history': h,
+            'posixpath': posixpath,
+            'navigation': navigation,
+        }
+        h.flush_cache()
+        self.log.info('/inventory %r: %r secs' % (revid, time.time() - z))
+        return vals

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2008-02-27 03:35:24 +0000
+++ loggerhead/controllers/revision_ui.py	2007-01-21 00:05:52 +0000
@@ -17,10 +17,14 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import datetime
+import logging
+import os
+import textwrap
 import time
 
 import turbogears
-from cherrypy import InternalError
+from cherrypy import HTTPRedirect, session
 
 from loggerhead import util
 
@@ -31,8 +35,7 @@
         # BranchView object
         self._branch = branch
         self.log = branch.log
-    
-#    @util.lsprof
+        
     @util.strip_whitespace
     @turbogears.expose(html='loggerhead.templates.revision')
     def default(self, *args, **kw):
@@ -40,56 +43,56 @@
         h = self._branch.get_history()
         util.set_context(kw)
         
-        h._branch.lock_read()
+        if len(args) > 0:
+            revid = h.fix_revid(args[0])
+        else:
+            revid = None
+        
+        file_id = kw.get('file_id', None)
+        start_revid = h.fix_revid(kw.get('start_revid', None))
+        query = kw.get('q', None)
+        remember = kw.get('remember', None)
+        compare_revid = kw.get('compare_revid', None)
+        
         try:
-            if len(args) > 0:
-                revid = h.fix_revid(args[0])
-            else:
-                revid = None
-
-            file_id = kw.get('file_id', None)
-            start_revid = h.fix_revid(kw.get('start_revid', None))
-            query = kw.get('q', None)
-            remember = kw.get('remember', None)
-            compare_revid = kw.get('compare_revid', None)
-
-            try:
-                revid, start_revid, revid_list = h.get_view(revid, start_revid, file_id, query)
-            except:
-                self.log.exception('Exception fetching changes')
-                raise InternalError('Could not fetch changes')
-
-            navigation = util.Container(revid_list=revid_list, revid=revid, start_revid=start_revid, file_id=file_id,
-                                        pagesize=1, scan_url='/revision', branch=self._branch, feed=True)
-            if query is not None:
-                navigation.query = query
-            util.fill_in_navigation(navigation)
-
-            change = h.get_change_with_diff(revid, compare_revid)
-            # add parent & merge-point branch-nick info, in case it's useful
-            h.get_branch_nicks([ change ])
-
-            # let's make side-by-side diff be the default
-            side_by_side = not kw.get('unified', False)
-            if side_by_side:
-                h.add_side_by_side([ change ])
-
-            vals = {
-                'branch': self._branch,
-                'revid': revid,
-                'change': change,
-                'start_revid': start_revid,
-                'file_id': file_id,
-                'util': util,
-                'history': h,
-                'navigation': navigation,
-                'query': query,
-                'remember': remember,
-                'compare_revid': compare_revid,
-                'side_by_side': side_by_side,
-            }
-            h.flush_cache()
-            self.log.info('/revision: %r seconds' % (time.time() - z,))
-            return vals
-        finally:
-            h._branch.unlock()
+            revid, start_revid, revid_list = h.get_view(revid, start_revid, file_id, query)
+        except Exception, x:
+            self.log.error('Exception fetching changes: %s' % (x,))
+            util.log_exception(self.log)
+            raise HTTPRedirect(self._branch.url('/changes'))
+        
+        navigation = util.Container(revid_list=revid_list, revid=revid, start_revid=start_revid, file_id=file_id,
+                                    pagesize=1, scan_url='/revision', branch=self._branch, feed=True)
+        if query is not None:
+            navigation.query = query
+        util.fill_in_navigation(h, navigation)
+
+        if compare_revid is not None:
+            change = h.get_diff(compare_revid, revid)
+        else:
+            change = h.get_changes([ revid ], get_diffs=True)[0]
+        # add parent & merge-point branch-nick info, in case it's useful
+        h.get_branch_nicks([ change ])
+
+        # let's make side-by-side diff be the default
+        side_by_side = not kw.get('unified', False)
+        if side_by_side:
+            h.add_side_by_side([ change ])
+        
+        vals = {
+            'branch': self._branch,
+            'revid': revid,
+            'change': change,
+            'start_revid': start_revid,
+            'file_id': file_id,
+            'util': util,
+            'history': h,
+            'navigation': navigation,
+            'query': query,
+            'remember': remember,
+            'compare_revid': compare_revid,
+            'side_by_side': side_by_side,
+        }
+        h.flush_cache()
+        self.log.info('/revision: %r seconds' % (time.time() - z,))
+        return vals

=== modified file 'loggerhead/daemon.py'
--- loggerhead/daemon.py	2008-02-27 03:36:09 +0000
+++ loggerhead/daemon.py	2007-01-14 05:40:40 +0000
@@ -1,6 +1,7 @@
 # daemon code from ASPN
 
 import os
+import sys
 
 
 def daemonize(pidfile, home):
@@ -19,58 +20,43 @@
     except OSError, e:
         raise Exception("%s [%d]" % (e.strerror, e.errno))
 
-    if (pid == 0):      # The first child.
+    if (pid == 0):	# The first child.
         os.setsid()
 
         try:
-            pid = os.fork()     # Fork a second child.
+            pid = os.fork()	# Fork a second child.
         except OSError, e:
             raise Exception, "%s [%d]" % (e.strerror, e.errno)
 
-        if (pid == 0):  # The second child.
+        if (pid == 0):	# The second child.
             os.chdir(WORKDIR)
             os.umask(UMASK)
         else:
-            os._exit(0) # Exit parent (the first child) of the second child.
+            os._exit(0)	# Exit parent (the first child) of the second child.
     else:
-        os._exit(0)     # Exit parent of the first child.
+        os._exit(0)	# Exit parent of the first child.
 
-    #import resource            # Resource usage information.
+    #import resource		# Resource usage information.
     #maxfd = resource.getrlimit(resource.RLIMIT_NOFILE)[1]
     #if (maxfd == resource.RLIM_INFINITY):
     #    maxfd = MAXFD
-
+  
     # Iterate through and close all file descriptors.
     #for fd in range(3, maxfd):
     #    try:
     #        os.close(fd)
-    #    except OSError:        # ERROR, fd wasn't open to begin with (ignored)
+    #    except OSError:	# ERROR, fd wasn't open to begin with (ignored)
     #        pass
 
     # This call to open is guaranteed to return the lowest file descriptor,
     # which will be 0 (stdin), since it was closed above.
-    #os.open(REDIRECT_TO, os.O_RDWR)    # standard input (0)
+    #os.open(REDIRECT_TO, os.O_RDWR)	# standard input (0)
 
     # Duplicate standard input to standard output and standard error.
-    #os.dup2(0, 1)                      # standard output (1)
-    #os.dup2(0, 2)                      # standard error (2)
+    #os.dup2(0, 1)			# standard output (1)
+    #os.dup2(0, 2)			# standard error (2)
 
     f = open(pidfile, 'w')
     f.write('%d\n' % (os.getpid(),))
     f.write('%s\n' % (home,))
     f.close()
-
-
-def is_running(pidfile):
-    try:
-        f = open(pidfile, 'r')
-    except IOError:
-        return False
-    pid = int(f.readline())
-    f.close()
-    try:
-        os.kill(pid, 0)
-    except OSError:
-        # no such process
-        return False
-    return True

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2008-03-05 23:02:07 +0000
+++ loggerhead/history.py	2007-03-06 06:37:21 +0000
@@ -27,9 +27,14 @@
 
 
 import bisect
+import cgi
 import datetime
 import logging
+import os
+import posixpath
 import re
+import shelve
+import sys
 import textwrap
 import threading
 import time
@@ -39,19 +44,20 @@
 from loggerhead.util import decorator
 
 import bzrlib
+import bzrlib.annotate
 import bzrlib.branch
 import bzrlib.bundle.serializer
+import bzrlib.decorators
 import bzrlib.diff
 import bzrlib.errors
 import bzrlib.progress
-import bzrlib.revision
+import bzrlib.textfile
 import bzrlib.tsort
 import bzrlib.ui
 
 
 with_branch_lock = util.with_lock('_lock', 'branch')
 
-
 @decorator
 def with_bzrlib_read_lock(unbound):
     def bzrlib_read_locked(self, *args, **kw):
@@ -94,7 +100,7 @@
     """
     turn a normal unified-style diff (post-processed by parse_delta) into a
     side-by-side diff structure.  the new structure is::
-
+    
         chunks: list(
             diff: list(
                 old_lineno: int,
@@ -136,40 +142,20 @@
 
 
 def clean_message(message):
-    """Clean up a commit message and return it and a short (1-line) version.
-
-    Commit messages that are long single lines are reflowed using the textwrap
-    module (Robey, the original author of this code, apparently favored this
-    style of message).
-    """
+    # clean up a commit message and return it and a short (1-line) version
     message = message.splitlines()
-
     if len(message) == 1:
+        # robey-style 1-line long message
         message = textwrap.wrap(message[0])
-
-    if len(message) == 0:
-        # We can end up where when (a) the commit message was empty or (b)
-        # when the message consisted entirely of whitespace, in which case
-        # textwrap.wrap() returns an empty list.
-        return [''], ''
-
-    # Make short form of commit message.
+        
+    # make short form of commit message
     short_message = message[0]
-    if len(short_message) > 80:
-        short_message = short_message[:80] + '...'
-
+    if len(short_message) > 60:
+        short_message = short_message[:60] + '...'
+    
     return message, short_message
 
 
-def rich_filename(path, kind):
-    if kind == 'directory':
-        path += '/'
-    if kind == 'symlink':
-        path += '@'
-    return path
-
-
-
 # from bzrlib
 class _RevListToTimestamps(object):
     """This takes a list of revisions, and allows you to bisect by date"""
@@ -189,84 +175,67 @@
 
 
 class History (object):
-
+    
     def __init__(self):
         self._change_cache = None
-        self._file_change_cache = None
         self._index = None
         self._lock = threading.RLock()
-
+    
     @classmethod
     def from_branch(cls, branch, name=None):
         z = time.time()
         self = cls()
         self._branch = branch
-        self._last_revid = self._branch.last_revision()
+        self._history = branch.revision_history()
+        self._last_revid = self._history[-1]
         self._revision_graph = branch.repository.get_revision_graph(self._last_revid)
-
+        
         if name is None:
             name = self._branch.nick
         self._name = name
         self.log = logging.getLogger('loggerhead.%s' % (name,))
-
+        
         self._full_history = []
         self._revision_info = {}
         self._revno_revid = {}
-        if bzrlib.revision.is_null(self._last_revid):
-            self._merge_sort = []
-        else:
-            self._merge_sort = bzrlib.tsort.merge_sort(
-                self._revision_graph, self._last_revid, generate_revno=True)
+        self._merge_sort = bzrlib.tsort.merge_sort(self._revision_graph, self._last_revid, generate_revno=True)
+        count = 0
         for (seq, revid, merge_depth, revno, end_of_merge) in self._merge_sort:
             self._full_history.append(revid)
             revno_str = '.'.join(str(n) for n in revno)
             self._revno_revid[revno_str] = revid
             self._revision_info[revid] = (seq, revid, merge_depth, revno_str, end_of_merge)
+            count += 1
+        self._count = count
+
         # cache merge info
         self._where_merged = {}
         for revid in self._revision_graph.keys():
-            if self._revision_info[revid][2] == 0:
+            if not revid in self._full_history: 
                 continue
             for parent in self._revision_graph[revid]:
                 self._where_merged.setdefault(parent, set()).add(revid)
 
         self.log.info('built revision graph cache: %r secs' % (time.time() - z,))
         return self
-
+    
     @classmethod
     def from_folder(cls, path, name=None):
         b = bzrlib.branch.Branch.open(path)
-        b.lock_read()
-        try:
-            return cls.from_branch(b, name)
-        finally:
-            b.unlock()
+        return cls.from_branch(b, name)
 
     @with_branch_lock
     def out_of_date(self):
-        # the branch may have been upgraded on disk, in which case we're stale.
-        newly_opened = bzrlib.branch.Branch.open(self._branch.base)
-        if self._branch.__class__ is not \
-               newly_opened.__class__:
-            return True
-        if self._branch.repository.__class__ is not \
-               newly_opened.repository.__class__:
-            return True
-        return self._branch.last_revision() != self._last_revid
+        if self._branch.revision_history()[-1] != self._last_revid:
+            return True
+        return False
 
     def use_cache(self, cache):
         self._change_cache = cache
-
-    def use_file_cache(self, cache):
-        self._file_change_cache = cache
-
+    
     def use_search_index(self, index):
         self._index = index
 
-    @property
-    def has_revisions(self):
-        return not bzrlib.revision.is_null(self.last_revid)
-
     @with_branch_lock
     def detach(self):
         # called when a new history object needs to be created, because the
@@ -285,19 +254,25 @@
         if self._change_cache is None:
             return
         self._change_cache.flush()
-
+    
     def check_rebuild(self):
         if self._change_cache is not None:
             self._change_cache.check_rebuild()
         if self._index is not None:
             self._index.check_rebuild()
-
+    
     last_revid = property(lambda self: self._last_revid, None, None)
+    
+    count = property(lambda self: self._count, None, None)
 
     @with_branch_lock
     def get_config(self):
         return self._branch.get_config()
-
+    
+    @with_branch_lock
+    def get_revision(self, revid):
+        return self._branch.repository.get_revision(revid)
+    
     def get_revno(self, revid):
         if revid not in self._revision_info:
             # ghost parent?
@@ -305,9 +280,24 @@
         seq, revid, merge_depth, revno_str, end_of_merge = self._revision_info[revid]
         return revno_str
 
+    def get_sequence(self, revid):
+        seq, revid, merge_depth, revno_str, end_of_merge = self._revision_info[revid]
+        return seq
+    
     def get_revision_history(self):
         return self._full_history
-
+    
+    def get_revid_sequence(self, revid_list, revid):
+        """
+        given a list of revision ids, return the sequence # of this revid in
+        the list.
+        """
+        seq = 0
+        for r in revid_list:
+            if revid == r:
+                return seq
+            seq += 1
+    
     def get_revids_from(self, revid_list, revid):
         """
         given a list of revision ids, yield revisions in graph order,
@@ -323,7 +313,7 @@
             if len(parents) == 0:
                 return
             revid = parents[0]
-
+    
     @with_branch_lock
     def get_short_revision_history_by_fileid(self, file_id):
         # wow.  is this really the only way we can get this list?  by
@@ -348,7 +338,7 @@
         revid_list.reverse()
         index = -index
         return revid_list[index:]
-
+    
     @with_branch_lock
     def get_revision_history_matching(self, revid_list, text):
         self.log.debug('searching %d revisions for %r', len(revid_list), text)
@@ -373,12 +363,12 @@
         # put them in some coherent order :)
         out = [r for r in self._full_history if r in out]
         return out
-
+    
     @with_branch_lock
     def get_search_revid_list(self, query, revid_list):
         """
         given a "quick-search" query, try a few obvious possible meanings:
-
+        
             - revision id or # ("128.1.3")
             - date (US style "mm/dd/yy", earth style "dd-mm-yy", or iso style "yyyy-mm-dd")
             - comment text as a fallback
@@ -388,16 +378,14 @@
         # FIXME: there is some silliness in this action.  we have to look up
         # all the relevant changes (time-consuming) only to return a list of
         # revids which will be used to fetch a set of changes again.
-
+        
         # if they entered a revid, just jump straight there; ignore the passed-in revid_list
         revid = self.fix_revid(query)
         if revid is not None:
-            if isinstance(revid, unicode):
-                revid = revid.encode('utf-8')
             changes = self.get_changes([ revid ])
             if (changes is not None) and (len(changes) > 0):
                 return [ revid ]
-
+        
         date = None
         m = self.us_date_re.match(query)
         if m is not None:
@@ -415,12 +403,12 @@
                 # if no limit to the query was given, search only the direct-parent path.
                 revid_list = list(self.get_revids_from(None, self._last_revid))
             return self.get_revision_history_since(revid_list, date)
-
+        
         # check comment fields.
         if revid_list is None:
             revid_list = self._full_history
         return self.get_revision_history_matching_indexed(revid_list, query)
-
+    
     revno_re = re.compile(r'^[\d\.]+$')
     # the date regex are without a final '$' so that queries like
     # "2006-11-30 12:15" still mostly work.  (i think it's better to give
@@ -433,74 +421,69 @@
         # if a "revid" is actually a dotted revno, convert it to a revid
         if revid is None:
             return revid
-        if revid == 'head:':
-            return self._last_revid
         if self.revno_re.match(revid):
             revid = self._revno_revid[revid]
         return revid
-
+    
     @with_branch_lock
     def get_file_view(self, revid, file_id):
         """
-        Given a revid and optional path, return a (revlist, revid) for
-        navigation through the current scope: from the revid (or the latest
-        revision) back to the original revision.
-
+        Given an optional revid and optional path, return a (revlist, revid)
+        for navigation through the current scope: from the revid (or the
+        latest revision) back to the original revision.
+        
         If file_id is None, the entire revision history is the list scope.
+        If revid is None, the latest revision is used.
         """
         if revid is None:
             revid = self._last_revid
         if file_id is not None:
-            # since revid is 'start_revid', possibly should start the path
-            # tracing from revid... FIXME
+            # since revid is 'start_revid', possibly should start the path tracing from revid... FIXME
+            inv = self._branch.repository.get_revision_inventory(revid)
             revlist = list(self.get_short_revision_history_by_fileid(file_id))
             revlist = list(self.get_revids_from(revlist, revid))
         else:
             revlist = list(self.get_revids_from(None, revid))
-        return revlist
-
+        if revid is None:
+            revid = revlist[0]
+        return revlist, revid
+    
     @with_branch_lock
     def get_view(self, revid, start_revid, file_id, query=None):
         """
         use the URL parameters (revid, start_revid, file_id, and query) to
         determine the revision list we're viewing (start_revid, file_id, query)
         and where we are in it (revid).
-
-            - if a query is given, we're viewing query results.
-            - if a file_id is given, we're viewing revisions for a specific
-              file.
-            - if a start_revid is given, we're viewing the branch from a
-              specific revision up the tree.
-
-        these may be combined to view revisions for a specific file, from
-        a specific revision, with a specific search query.
-
-        returns a new (revid, start_revid, revid_list) where:
-
+        
+        if a query is given, we're viewing query results.
+        if a file_id is given, we're viewing revisions for a specific file.
+        if a start_revid is given, we're viewing the branch from a
+            specific revision up the tree.
+        (these may be combined to view revisions for a specific file, from
+            a specific revision, with a specific search query.)
+            
+        returns a new (revid, start_revid, revid_list, scan_list) where:
+        
             - revid: current position within the view
             - start_revid: starting revision of this view
             - revid_list: list of revision ids for this view
-
+        
         file_id and query are never changed so aren't returned, but they may
         contain vital context for future url navigation.
         """
-        if start_revid is None:
-            start_revid = self._last_revid
-
         if query is None:
-            revid_list = self.get_file_view(start_revid, file_id)
+            revid_list, start_revid = self.get_file_view(start_revid, file_id)
             if revid is None:
                 revid = start_revid
             if revid not in revid_list:
                 # if the given revid is not in the revlist, use a revlist that
                 # starts at the given revid.
-                revid_list= self.get_file_view(revid, file_id)
-                start_revid = revid
+                revid_list, start_revid = self.get_file_view(revid, file_id)
             return revid, start_revid, revid_list
-
+        
         # potentially limit the search
-        if file_id is not None:
-            revid_list = self.get_file_view(start_revid, file_id)
+        if (start_revid is not None) or (file_id is not None):
+            revid_list, start_revid = self.get_file_view(start_revid, file_id)
         else:
             revid_list = None
 
@@ -525,24 +508,23 @@
         if (len(path) > 0) and not path.startswith('/'):
             path = '/' + path
         return path
-
-    @with_branch_lock
-    def get_file_id(self, revid, path):
-        if (len(path) > 0) and not path.startswith('/'):
-            path = '/' + path
-        return self._branch.repository.get_revision_inventory(revid).path2id(path)
-
-
+    
+    def get_where_merged(self, revid):
+        try:
+            return self._where_merged[revid]
+        except:
+            return []
+    
     def get_merge_point_list(self, revid):
         """
         Return the list of revids that have merged this node.
         """
-        if '.' not in self.get_revno(revid):
+        if revid in self._history:
             return []
-
+        
         merge_point = []
         while True:
-            children = self._where_merged.get(revid, [])
+            children = self.get_where_merged(revid)
             nexts = []
             for child in children:
                 child_parents = self._revision_graph[child]
@@ -562,7 +544,7 @@
                 merge_point.extend(merge_point_next)
 
             revid = nexts[0]
-
+            
     def simplify_merge_point_list(self, revids):
         """if a revision is already merged, don't show further merge points"""
         d = {}
@@ -605,152 +587,127 @@
                     p.branch_nick = p_change_dict[p.revid].branch_nick
                 else:
                     p.branch_nick = '(missing)'
-
+    
     @with_branch_lock
-    def get_changes(self, revid_list):
-        """Return a list of changes objects for the given revids.
-
-        Revisions not present and NULL_REVISION will be ignored.
-        """
+    def get_changes(self, revid_list, get_diffs=False):
         if self._change_cache is None:
-            changes = self.get_changes_uncached(revid_list)
+            changes = self.get_changes_uncached(revid_list, get_diffs)
         else:
-            changes = self._change_cache.get_changes(revid_list)
-        if len(changes) == 0:
+            changes = self._change_cache.get_changes(revid_list, get_diffs)
+        if changes is None:
             return changes
-
+        
         # some data needs to be recalculated each time, because it may
         # change as new revisions are added.
-        for change in changes:
-            merge_revids = self.simplify_merge_point_list(self.get_merge_point_list(change.revid))
+        for i in xrange(len(revid_list)):
+            revid = revid_list[i]
+            change = changes[i]
+            merge_revids = self.simplify_merge_point_list(self.get_merge_point_list(revid))
             change.merge_points = [util.Container(revid=r, revno=self.get_revno(r)) for r in merge_revids]
-            if len(change.parents) > 0:
-                if isinstance(change.parents[0], util.Container):
-                    # old cache stored a potentially-bogus revno
-                    change.parents = [util.Container(revid=p.revid, revno=self.get_revno(p.revid)) for p in change.parents]
-                else:
-                    change.parents = [util.Container(revid=r, revno=self.get_revno(r)) for r in change.parents]
-            change.revno = self.get_revno(change.revid)
-
-        parity = 0
-        for change in changes:
-            change.parity = parity
-            parity ^= 1
-
+        
         return changes
 
-    # alright, let's profile this sucka. (FIXME remove this eventually...)
-    def _get_changes_profiled(self, revid_list):
+    # alright, let's profile this sucka.
+    def _get_changes_profiled(self, revid_list, get_diffs=False):
         from loggerhead.lsprof import profile
         import cPickle
-        ret, stats = profile(self.get_changes_uncached, revid_list)
+        ret, stats = profile(self.get_changes_uncached, revid_list, get_diffs)
         stats.sort()
         stats.freeze()
         cPickle.dump(stats, open('lsprof.stats', 'w'), 2)
         self.log.info('lsprof complete!')
         return ret
 
-    @with_branch_lock
-    @with_bzrlib_read_lock
-    def get_changes_uncached(self, revid_list):
-        revid_list = filter(lambda revid: not bzrlib.revision.is_null(revid),
-                            revid_list)
-        repo = self._branch.repository
-        parent_map = repo.get_graph().get_parent_map(revid_list)
-        present_revids = filter(lambda revid:revid in parent_map, revid_list)
-        rev_list = repo.get_revisions(present_revids)
-
-        return [self._change_from_revision(rev) for rev in rev_list]
-
     def _get_deltas_for_revisions_with_trees(self, revisions):
-        """Produce a list of revision deltas.
-
+        """Produce a generator of revision deltas.
+        
         Note that the input is a sequence of REVISIONS, not revision_ids.
         Trees will be held in memory until the generator exits.
         Each delta is relative to the revision's lefthand predecessor.
-        (This is copied from bzrlib.)
         """
         required_trees = set()
         for revision in revisions:
-            required_trees.add(revision.revid)
-            required_trees.update([p.revid for p in revision.parents[:1]])
-        trees = dict((t.get_revision_id(), t) for
+            required_trees.add(revision.revision_id)
+            required_trees.update(revision.parent_ids[:1])
+        trees = dict((t.get_revision_id(), t) for 
                      t in self._branch.repository.revision_trees(required_trees))
         ret = []
         self._branch.repository.lock_read()
         try:
             for revision in revisions:
-                if not revision.parents:
-                    old_tree = self._branch.repository.revision_tree(
-                        bzrlib.revision.NULL_REVISION)
+                if not revision.parent_ids:
+                    old_tree = self._branch.repository.revision_tree(None)
                 else:
-                    old_tree = trees[revision.parents[0].revid]
-                tree = trees[revision.revid]
-                ret.append(tree.changes_from(old_tree))
+                    old_tree = trees[revision.parent_ids[0]]
+                tree = trees[revision.revision_id]
+                ret.append((tree, old_tree, tree.changes_from(old_tree)))
             return ret
         finally:
             self._branch.repository.unlock()
-
-    def _change_from_revision(self, revision):
-        """
-        Given a bzrlib Revision, return a processed "change" for use in
-        templates.
-        """
+    
+    def entry_from_revision(self, revision):
         commit_time = datetime.datetime.fromtimestamp(revision.timestamp)
-
+        
         parents = [util.Container(revid=r, revno=self.get_revno(r)) for r in revision.parent_ids]
 
+        if len(parents) == 0:
+            left_parent = None
+        else:
+            left_parent = revision.parent_ids[0]
+        
         message, short_message = clean_message(revision.message)
 
         entry = {
             'revid': revision.revision_id,
+            'revno': self.get_revno(revision.revision_id),
             'date': commit_time,
             'author': revision.committer,
             'branch_nick': revision.properties.get('branch-nick', None),
             'short_comment': short_message,
             'comment': revision.message,
             'comment_clean': [util.html_clean(s) for s in message],
-            'parents': revision.parent_ids,
+            'parents': parents,
         }
         return util.Container(entry)
 
-    def get_file_changes_uncached(self, entries):
-        delta_list = self._get_deltas_for_revisions_with_trees(entries)
-
-        return [self.parse_delta(delta) for delta in delta_list]
-
-    @with_branch_lock
-    def get_file_changes(self, entries):
-        if self._file_change_cache is None:
-            return self.get_file_changes_uncached(entries)
-        else:
-            return self._file_change_cache.get_file_changes(entries)
-
-    def add_changes(self, entries):
-        changes_list = self.get_file_changes(entries)
-
-        for entry, changes in zip(entries, changes_list):
-            entry.changes = changes
-
-    @with_branch_lock
-    def get_change_with_diff(self, revid, compare_revid=None):
-        change = self.get_changes([revid])[0]
-
-        if compare_revid is None:
-            if change.parents:
-                compare_revid = change.parents[0].revid
-            else:
-                compare_revid = 'null:'
-
-        rev_tree1 = self._branch.repository.revision_tree(compare_revid)
-        rev_tree2 = self._branch.repository.revision_tree(revid)
+    @with_branch_lock
+    @with_bzrlib_read_lock
+    def get_changes_uncached(self, revid_list, get_diffs=False):
+        done = False
+        while not done:
+            try:
+                rev_list = self._branch.repository.get_revisions(revid_list)
+                done = True
+            except (KeyError, bzrlib.errors.NoSuchRevision), e:
+                # this sometimes happens with arch-converted branches.
+                # i don't know why. :(
+                self.log.debug('No such revision (skipping): %s', e)
+                revid_list.remove(e.revision)
+        
+        delta_list = self._get_deltas_for_revisions_with_trees(rev_list)
+        combined_list = zip(rev_list, delta_list)
+        
+        entries = []
+        for rev, (new_tree, old_tree, delta) in combined_list:
+            entry = self.entry_from_revision(rev)
+            entry.changes = self.parse_delta(delta, get_diffs, old_tree, new_tree)
+            entries.append(entry)
+        
+        return entries
+
+    @with_bzrlib_read_lock
+    def _get_diff(self, revid1, revid2):
+        rev_tree1 = self._branch.repository.revision_tree(revid1)
+        rev_tree2 = self._branch.repository.revision_tree(revid2)
         delta = rev_tree2.changes_from(rev_tree1)
-
-        change.changes = self.parse_delta(delta)
-        change.changes.modified = self._parse_diffs(rev_tree1, rev_tree2, delta)
-
-        return change
-
+        return rev_tree1, rev_tree2, delta
+    
+    def get_diff(self, revid1, revid2):
+        rev_tree1, rev_tree2, delta = self._get_diff(revid1, revid2)
+        entry = self.get_changes([ revid2 ], False)[0]
+        entry.changes = self.parse_delta(delta, True, rev_tree1, rev_tree2)
+        return entry
+    
     @with_branch_lock
     def get_file(self, file_id, revid):
         "returns (path, filename, data)"
@@ -761,12 +718,16 @@
         if not path.startswith('/'):
             path = '/' + path
         return path, inv_entry.name, rev_tree.get_file_text(file_id)
-
-    def _parse_diffs(self, old_tree, new_tree, delta):
+    
+    @with_branch_lock
+    def parse_delta(self, delta, get_diffs=True, old_tree=None, new_tree=None):
         """
-        Return a list of processed diffs, in the format::
-
-            list(
+        Return a nested data structure containing the changes in a delta::
+        
+            added: list((filename, file_id)),
+            renamed: list((old_filename, new_filename, file_id)),
+            deleted: list((filename, file_id)),
+            modified: list(
                 filename: str,
                 file_id: str,
                 chunks: list(
@@ -778,103 +739,83 @@
                     ),
                 ),
             )
-        """
-        process = []
-        out = []
-
-        for old_path, new_path, fid, kind, text_modified, meta_modified in delta.renamed:
-            if text_modified:
-                process.append((old_path, new_path, fid, kind))
-        for path, fid, kind, text_modified, meta_modified in delta.modified:
-            process.append((path, path, fid, kind))
-
-        for old_path, new_path, fid, kind in process:
-            old_lines = old_tree.get_file_lines(fid)
-            new_lines = new_tree.get_file_lines(fid)
-            buffer = StringIO()
-            if old_lines != new_lines:
-                try:
-                    bzrlib.diff.internal_diff(old_path, old_lines,
-                                              new_path, new_lines, buffer)
-                except bzrlib.errors.BinaryFile:
-                    diff = ''
-                else:
-                    diff = buffer.getvalue()
-            else:
-                diff = ''
-            out.append(util.Container(filename=rich_filename(new_path, kind), file_id=fid, chunks=self._process_diff(diff)))
-
-        return out
-
-    def _process_diff(self, diff):
-        # doesn't really need to be a method; could be static.
-        chunks = []
-        chunk = None
-        for line in diff.splitlines():
-            if len(line) == 0:
-                continue
-            if line.startswith('+++ ') or line.startswith('--- '):
-                continue
-            if line.startswith('@@ '):
-                # new chunk
-                if chunk is not None:
-                    chunks.append(chunk)
-                chunk = util.Container()
-                chunk.diff = []
-                lines = [int(x.split(',')[0][1:]) for x in line.split(' ')[1:3]]
-                old_lineno = lines[0]
-                new_lineno = lines[1]
-            elif line.startswith(' '):
-                chunk.diff.append(util.Container(old_lineno=old_lineno, new_lineno=new_lineno,
-                                                 type='context', line=util.fixed_width(line[1:])))
-                old_lineno += 1
-                new_lineno += 1
-            elif line.startswith('+'):
-                chunk.diff.append(util.Container(old_lineno=None, new_lineno=new_lineno,
-                                                 type='insert', line=util.fixed_width(line[1:])))
-                new_lineno += 1
-            elif line.startswith('-'):
-                chunk.diff.append(util.Container(old_lineno=old_lineno, new_lineno=None,
-                                                 type='delete', line=util.fixed_width(line[1:])))
-                old_lineno += 1
-            else:
-                chunk.diff.append(util.Container(old_lineno=None, new_lineno=None,
-                                                 type='unknown', line=util.fixed_width(repr(line))))
-        if chunk is not None:
-            chunks.append(chunk)
-        return chunks
-
-    def parse_delta(self, delta):
-        """
-        Return a nested data structure containing the changes in a delta::
-
-            added: list((filename, file_id)),
-            renamed: list((old_filename, new_filename, file_id)),
-            deleted: list((filename, file_id)),
-            modified: list(
-                filename: str,
-                file_id: str,
-            )
+        
+        if C{get_diffs} is false, the C{chunks} will be omitted.
         """
         added = []
         modified = []
         renamed = []
         removed = []
+        
+        def rich_filename(path, kind):
+            if kind == 'directory':
+                path += '/'
+            if kind == 'symlink':
+                path += '@'
+            return path
+        
+        def process_diff(diff):
+            chunks = []
+            chunk = None
+            for line in diff.splitlines():
+                if len(line) == 0:
+                    continue
+                if line.startswith('+++ ') or line.startswith('--- '):
+                    continue
+                if line.startswith('@@ '):
+                    # new chunk
+                    if chunk is not None:
+                        chunks.append(chunk)
+                    chunk = util.Container()
+                    chunk.diff = []
+                    lines = [int(x.split(',')[0][1:]) for x in line.split(' ')[1:3]]
+                    old_lineno = lines[0]
+                    new_lineno = lines[1]
+                elif line.startswith(' '):
+                    chunk.diff.append(util.Container(old_lineno=old_lineno, new_lineno=new_lineno,
+                                                     type='context', line=util.html_clean(line[1:])))
+                    old_lineno += 1
+                    new_lineno += 1
+                elif line.startswith('+'):
+                    chunk.diff.append(util.Container(old_lineno=None, new_lineno=new_lineno,
+                                                     type='insert', line=util.html_clean(line[1:])))
+                    new_lineno += 1
+                elif line.startswith('-'):
+                    chunk.diff.append(util.Container(old_lineno=old_lineno, new_lineno=None,
+                                                     type='delete', line=util.html_clean(line[1:])))
+                    old_lineno += 1
+                else:
+                    chunk.diff.append(util.Container(old_lineno=None, new_lineno=None,
+                                                     type='unknown', line=util.html_clean(repr(line))))
+            if chunk is not None:
+                chunks.append(chunk)
+            return chunks
+                    
+        def handle_modify(old_path, new_path, fid, kind):
+            if not get_diffs:
+                modified.append(util.Container(filename=rich_filename(new_path, kind), file_id=fid))
+                return
+            old_lines = old_tree.get_file_lines(fid)
+            new_lines = new_tree.get_file_lines(fid)
+            buffer = StringIO()
+            bzrlib.diff.internal_diff(old_path, old_lines, new_path, new_lines, buffer)
+            diff = buffer.getvalue()
+            modified.append(util.Container(filename=rich_filename(new_path, kind), file_id=fid, chunks=process_diff(diff), raw_diff=diff))
 
         for path, fid, kind in delta.added:
             added.append((rich_filename(path, kind), fid))
-
+        
         for path, fid, kind, text_modified, meta_modified in delta.modified:
-            modified.append(util.Container(filename=rich_filename(path, kind), file_id=fid))
-
-        for old_path, new_path, fid, kind, text_modified, meta_modified in delta.renamed:
-            renamed.append((rich_filename(old_path, kind), rich_filename(new_path, kind), fid))
+            handle_modify(path, path, fid, kind)
+        
+        for oldpath, newpath, fid, kind, text_modified, meta_modified in delta.renamed:
+            renamed.append((rich_filename(oldpath, kind), rich_filename(newpath, kind), fid))
             if meta_modified or text_modified:
-                modified.append(util.Container(filename=rich_filename(new_path, kind), file_id=fid))
-
+                handle_modify(oldpath, newpath, fid, kind)
+        
         for path, fid, kind in delta.removed:
             removed.append((rich_filename(path, kind), fid))
-
+        
         return util.Container(added=added, renamed=renamed, removed=removed, modified=modified)
 
     @staticmethod
@@ -883,47 +824,50 @@
         for change in changes:
             for m in change.changes.modified:
                 m.sbs_chunks = _make_side_by_side(m.chunks)
-
+    
     @with_branch_lock
-    def get_filelist(self, inv, file_id, sort_type=None):
+    def get_filelist(self, inv, path, sort_type=None):
         """
         return the list of all files (and their attributes) within a given
         path subtree.
         """
-
-        dir_ie = inv[file_id]
-        path = inv.id2path(file_id)
+        while path.endswith('/'):
+            path = path[:-1]
+        if path.startswith('/'):
+            path = path[1:]
+        
+        entries = inv.entries()
+        
+        fetch_set = set()
+        for filepath, entry in entries:
+            fetch_set.add(entry.revision)
+        change_dict = dict([(c.revid, c) for c in self.get_changes(list(fetch_set))])
+        
         file_list = []
-
-        revid_set = set()
-
-        for filename, entry in dir_ie.children.iteritems():
-            revid_set.add(entry.revision)
-
-        change_dict = {}
-        for change in self.get_changes(list(revid_set)):
-            change_dict[change.revid] = change
-
-        for filename, entry in dir_ie.children.iteritems():
+        for filepath, entry in entries:
+            if posixpath.dirname(filepath) != path:
+                continue
+            filename = posixpath.basename(filepath)
+            rich_filename = filename
             pathname = filename
             if entry.kind == 'directory':
                 pathname += '/'
-
+            
+            # last change:
             revid = entry.revision
-
-            file = util.Container(
-                filename=filename, executable=entry.executable, kind=entry.kind,
-                pathname=pathname, file_id=entry.file_id, size=entry.text_size,
-                revid=revid, change=change_dict[revid])
+            change = change_dict[revid]
+            
+            file = util.Container(filename=filename, rich_filename=rich_filename, executable=entry.executable, kind=entry.kind,
+                                  pathname=pathname, file_id=entry.file_id, size=entry.text_size, revid=revid, change=change)
             file_list.append(file)
-
-        if sort_type == 'filename' or sort_type is None:
+        
+        if sort_type == 'filename':
             file_list.sort(key=lambda x: x.filename)
         elif sort_type == 'size':
             file_list.sort(key=lambda x: x.size)
         elif sort_type == 'date':
             file_list.sort(key=lambda x: x.change.date)
-
+        
         parity = 0
         for file in file_list:
             file.parity = parity
@@ -932,33 +876,33 @@
         return file_list
 
 
-    _BADCHARS_RE = re.compile(ur'[\x00-\x08\x0b\x0e-\x1f]')
+    _BADCHARS_RE = re.compile(ur'[\x00-\x08\x0b-\x0c\x0e-\x1f]')
 
     @with_branch_lock
     def annotate_file(self, file_id, revid):
         z = time.time()
         lineno = 1
         parity = 0
-
+        
         file_revid = self.get_inventory(revid)[file_id].revision
         oldvalues = None
-
+        
         # because we cache revision metadata ourselves, it's actually much
         # faster to call 'annotate_iter' on the weave directly than it is to
         # ask bzrlib to annotate for us.
         w = self._branch.repository.weave_store.get_weave(file_id, self._branch.repository.get_transaction())
-
+        
         revid_set = set()
         for line_revid, text in w.annotate_iter(file_revid):
             revid_set.add(line_revid)
             if self._BADCHARS_RE.match(text):
                 # bail out; this isn't displayable text
                 yield util.Container(parity=0, lineno=1, status='same',
-                                     text='(This is a binary file.)',
+                                     text='<i>' + util.html_clean('(This is a binary file.)') + '</i>',
                                      change=util.Container())
                 return
         change_cache = dict([(c.revid, c) for c in self.get_changes(list(revid_set))])
-
+        
         last_line_revid = None
         for line_revid, text in w.annotate_iter(file_revid):
             if line_revid == last_line_revid:
@@ -972,14 +916,15 @@
                 trunc_revno = change.revno
                 if len(trunc_revno) > 10:
                     trunc_revno = trunc_revno[:9] + '...'
-
+                
             yield util.Container(parity=parity, lineno=lineno, status=status,
-                                 change=change, text=util.fixed_width(text))
+                                 change=change, text=util.html_clean(text))
             lineno += 1
-
+        
         self.log.debug('annotate: %r secs' % (time.time() - z,))
 
     @with_branch_lock
+    @with_bzrlib_read_lock
     def get_bundle(self, revid, compare_revid=None):
         if compare_revid is None:
             parents = self._revision_graph[revid]
@@ -990,3 +935,4 @@
         s = StringIO()
         bzrlib.bundle.serializer.write_bundle(self._branch.repository, revid, compare_revid, s)
         return s.getvalue()
+

=== added file 'loggerhead/json.py'
--- loggerhead/json.py	1970-01-01 00:00:00 +0000
+++ loggerhead/json.py	2006-12-11 06:44:19 +0000
@@ -0,0 +1,12 @@
+# This module provides helper functions for the JSON part of your
+# view, if you are providing a JSON-based API for your app.
+
+# Here's what most rules would look like:
+# @jsonify.when("isinstance(obj, YourClass)")
+# def jsonify_yourclass(obj):
+#     return [obj.val1, obj.val2]
+# The goal is to break your objects down into simple values:
+# lists, dicts, numbers and strings
+
+from turbojson.jsonify import jsonify
+

=== modified file 'loggerhead/lockfile.py'
--- loggerhead/lockfile.py	2008-02-27 03:36:09 +0000
+++ loggerhead/lockfile.py	2007-01-14 01:20:39 +0000
@@ -35,7 +35,7 @@
     lock may be acquired multiple times by the same thread, as long as it's
     released an equal number of times.  unlike threading.Lock, this lock can
     be used across processes.
-
+    
     this uses os.open(O_CREAT|O_EXCL), which apparently works even on windows,
     but will not work over NFS, if anyone still uses that.  so don't put the
     cache folder on an NFS server...
@@ -50,7 +50,7 @@
             # remove stale locks left over from a previous run
             if time.time() - os.stat(filename).st_mtime > MAX_STALE_TIME:
                 os.remove(filename)
-
+    
     @with_lock
     def _try_acquire(self):
         if self._count > 0:
@@ -63,7 +63,7 @@
             return True
         except OSError:
             return False
-
+    
     def acquire(self):
         # try over and over, sleeping on exponential backoff with an upper limit of about 5 seconds
         pause = 0.1

=== modified file 'loggerhead/lsprof.py'
--- loggerhead/lsprof.py	2008-02-27 03:36:09 +0000
+++ loggerhead/lsprof.py	2006-12-15 01:14:05 +0000
@@ -36,7 +36,7 @@
         for pp in _g_threadmap.values():
             pp.disable()
         threading.setprofile(None)
-
+    
     threads = {}
     for tid, pp in _g_threadmap.items():
         threads[tid] = Stats(pp.getstats(), {})
@@ -112,7 +112,7 @@
         self.out_file = None
 
     def output(self, out_file):
-        self.out_file = out_file
+        self.out_file = out_file        
         print >> out_file, 'events: Ticks'
         self._print_summary()
         for entry in self.data:

=== added file 'loggerhead/model.py'
--- loggerhead/model.py	1970-01-01 00:00:00 +0000
+++ loggerhead/model.py	2006-12-11 06:44:19 +0000
@@ -0,0 +1,10 @@
+from sqlobject import *
+
+from turbogears.database import PackageHub
+
+hub = PackageHub("loggerhead")
+__connection__ = hub
+
+# class YourDataClass(SQLObject):
+#     pass
+

=== modified file 'loggerhead/release.py'
--- loggerhead/release.py	2008-03-06 01:59:26 +0000
+++ loggerhead/release.py	2007-01-24 19:29:58 +0000
@@ -1,6 +1,6 @@
 # Release information about loggerhead
 
-version = "1.2.1"
+version = "1.1.1-0.13"
 
 description = "Loggerhead is a web viewer for projects in bazaar."
 
@@ -8,5 +8,5 @@
 email = "robey@lag.net"
 
 license = "GPL"
-url = "http://launchpad.net/loggerhead"
-download_url = "https://launchpad.net/loggerhead/trunk/1.2/+download/loggerhead-1.2.tar.gz"
+url = "http://www.lag.net/loggerhead/"
+download_url = "http://www.lag.net/loggerhead/download/loggerhead-1.1.1-0.13.tar.gz"

=== modified file 'loggerhead/static/css/style.css'
--- loggerhead/static/css/style.css	2007-09-04 01:47:51 +0000
+++ loggerhead/static/css/style.css	2007-01-24 19:17:40 +0000
@@ -25,7 +25,7 @@
     color: #708a96;
     font-weight: normal;
     font-size: 1.6em;
-    margin-bottom: 1em;
+    margin-bottom: 1.5em;
 }
 h1 .filename {
     font-family: monospace;
@@ -201,65 +201,68 @@
 /* ----- changelog page ----- */
 
 /* secret css-jutsu to make hidden margins vanish on a table */
-.log-entries {
+.log-entries table {
     border-collapse: collapse;
-    width: 98%;
-    margin-top: 0.5em;
-    margin-left: 1em;
-}
-
-.log-entries .log-header {
-    background-color: #8cacbb;
-    padding-top: 3px;
-    padding-bottom: 3px;
-    text-align: left;
+    width: 100%;
 }
 
 .log-entries .revision-header {
-    font-size: 1.0em;
-}
-
-.log-entries .revision-header td {
-    padding-top: 2px;
-    padding-bottom: 2px;
+    background-color: #dee7ec;
+    padding: 3px;
+    width: 80%;
+    margin-top: 1em;
+    margin-left: 1em;
 }
 
 .log-entries .revision-header td.expand-button {
     width: 20px;
 }
 
-.log-entries .revision-number {
+.log-entries .revision-header .revision-number {
+    width: 6em;
     padding-left: 0.5em;
 }
 
-.log-entries .revision-header td.date {
-    font-size: smaller;
-}
-
-.log-entries .revision-header td.author {
-    font-size: smaller;
-    padding-right: 0.5em;
-}
-
 .log-entries .revision-header .inventory-link {
     font-size: smaller;
     vertical-align: middle;
-    text-align: left;
+    width: 4em;
+    text-align: right;
     padding-right: 0.5em;
 }
 
-.log-entries table.revision-details {
+.log-entries .revision-details-block {
+    width: 80%;
+    border: none;
+    margin-left: 8em;
+    margin-bottom: 1.5em;
+}
+
+.log-entries .revision-details table {
     font-size: smaller;
-    margin-bottom: 1.0em;
+    width: 100%;
 }
 
-.log-entries table.revision-details th {
+.log-entries .revision-details th {
+    width: 8em;
     text-align: right;
     padding-right: 0.5em;
     vertical-align: top;
 }
 
-.log-entries table.revision-details td.files .filename {
+.log-entries .revision-details td.date {
+/*    font-family: monospace; */
+}
+
+.log-entries .revision-details th.files {
+    padding-top: 1em;
+}
+
+.log-entries .revision-details td.files {
+    padding-top: 1em;
+}
+
+.log-entries .revision-details td.files .filename {
     font-family: monospace;
 }
 
@@ -267,8 +270,12 @@
     font-size: smaller;
 }
 
+.log-entries .revision-details th.description {
+    padding-top: 1em;
+}
 .log-entries .revision-details td.description {
     font-family: monospace;
+    padding-top: 1em;
 }
 
 /* default state: hide all */
@@ -315,6 +322,10 @@
     padding-bottom: 2px;
 }
 
+.revision-info table td.date {
+    font-family: monospace;
+}
+
 .revision-info table td.description {
     font-family: monospace;
 }
@@ -400,7 +411,7 @@
 .diff-option-buttons .collapse-file-showall { display: none; }
 
 .diff-block .show-button { display: none; }
-.collapse-style-unified-content { display: none; }
+.diff .collapse-style-unified-content { display: none; }
 .collapse-style-sbs-show { display: none; }
 
 .diff-insert {
@@ -459,7 +470,7 @@
 
 table.inventory {
     border-collapse: collapse;
-    width: 100%;
+    width: 80%;
     font-size: smaller;
     margin-top: 1em;
     border: 1px solid #8cacbb;
@@ -487,8 +498,8 @@
 
 .inventory td.permissions {
     font-family: monospace;
-    padding-left: 0.5em;
     width: 9em;
+    padding-left: 0.5em;
 }
 
 .inventory td.filename {
@@ -496,32 +507,31 @@
 }
 
 .inventory td.size {
-    font-family: monospace;
-    font-size: smaller;
-    width: 5em;
-    line-height: 1em;
-    vertical-align: bottom;
+	font-family: monospace;
+	font-size: smaller;
+	width: 5em;
 }
 
 .inventory td.revision {
-    padding-right: 1em;
-    text-align: left;
     width: 8em;
+    padding-right: 1.5em;
 }
 
 .inventory td.date {
-    padding-right: 1em;
-    width: 11em;
+    font-family: monospace;
+    font-size: smaller;
+    width: 10em;
+    padding-right: 1.5em;
 }
 
 .inventory td.changes-link {
+    width: 6em;
     font-size: smaller;
-    width: 6em;
 }
 
 .inventory td.download-link {
+    width: 8em;
     font-size: smaller;
-    width: 8em;
 }
 
 span.folder {
@@ -629,23 +639,23 @@
 }
 
 .browse-view td,.browse-view th {
-    padding: 0.25em 0.5em 0.25em 0.5em;
+	padding: 0.25em 0.5em 0.25em 0.5em;
 }
 
 .browse-view td.name {
-    width: 20%;
+	width: 20%;
 }
 
 .browse-view td.last-update {
-    font-size: smaller;
-    width: 20em;
+	font-size: smaller;
+	width: 15%;
 }
 
 .browse-view td.url {
-    font-family: monospace;
-    font-size: smaller;
-    padding-left: 3em;
-    padding-top: 0px;
+	font-family: monospace;
+	font-size: smaller;
+	padding-left: 3em;
+	padding-top: 0px;
 }
 
 .browse-view td.feed {

=== modified file 'loggerhead/templates/annotate.kid'
--- loggerhead/templates/annotate.kid	2007-09-04 17:06:03 +0000
+++ loggerhead/templates/annotate.kid	2007-01-21 00:05:52 +0000
@@ -15,7 +15,7 @@
 	    <div> <b>&#8594;</b> <a href="${branch.url([ '/files', revid ], **util.get_context(clear=1))}"> browse files </a> </div>
 	    <div> <b>&#8594;</b> <a href="${branch.url('/revision', **util.get_context(clear=1, start_revid=revid))}"> view revision </a> </div>
 	    <div> <b>&#8594;</b> <a href="${branch.url('/changes', **util.get_context(clear=1, start_revid=revid, file_id=file_id))}"> view changes to this file </a> </div>
-	    <div> <b>&#8594;</b> <a href="${branch.url([ '/download', revid, file_id, filename ])}"> download file </a> </div>
+	    <div> <b>&#8594;</b> <a href="${branch.url([ '/download', revid, file_id, filename ])}"> view/download file </a> </div>
 	</div>
 </h1>
 
@@ -28,12 +28,12 @@
         </tr>
 
         <tr py:for="line in contents" class="parity${line.parity}">
-            <td class="lineno ${line.status}"><a name="L${line.lineno}"> ${line.lineno} </a></td>
+            <td class="lineno ${line.status}"> ${line.lineno} </td>
             <td class="revno ${line.status}">
                 <a py:if="line.status=='changed'" href="${branch.url('/revision', **util.get_context(clear=1, start_revid=line.change.revid, file_id=file_id))}"
-                    title="${line.change.revno} by ${util.hide_email(line.change.author)}, on ${util.format_date(line.change.date)} (${util.ago(line.change.date)})">${util.trunc(line.change.revno)}</a>
+                    title="${line.change.revno} by ${util.hide_email(line.change.author)}, on ${line.change.date.strftime('%d %b %Y %H:%M')} (${util.ago(line.change.date)})">${util.trunc(line.change.revno)}</a>
             </td>
-            <td class="text ${line.status}"> ${line.text} </td>
+            <td class="text ${line.status}"> ${XML(line.text)} </td>
         </tr>
     </table>
 </div>

=== modified file 'loggerhead/templates/atom.kid'
--- loggerhead/templates/atom.kid	2007-03-29 06:55:55 +0000
+++ loggerhead/templates/atom.kid	2006-12-20 21:24:32 +0000
@@ -2,18 +2,17 @@
 <feed xmlns="http://www.w3.org/2005/Atom" xmlns:py="http://purl.org/kid/ns#">
     <title> bazaar changes for ${branch.friendly_name} </title>
     <updated>${updated}</updated>
-    <id>${branch.url(['atom'])}</id>
-    <link rel="self" href="${branch.url([''])}" />
+    <id>${tg.url([ external_url, branch.group_name, branch.name, 'atom' ])}</id>
+    <link rel="self" href="${tg.url([ external_url, branch.group_name, branch.name, 'atom' ])}" />
 
 	<entry py:for="entry in changes">
 	    <title> ${entry.revno}: ${entry.short_comment} </title>
 	    <updated>${entry.date.isoformat() + 'Z'}</updated>
-	    <id>${branch.url(['revision', entry.revid ])}</id>
+	    <id>${tg.url([ external_url, branch.group_name, branch.name, 'revision', entry.revid ])}</id>
 	    <author> <name> ${util.hide_email(entry.author)} </name> </author>
 	    <content type="text">
             ${entry.comment}
 	    </content>
-	    <link rel="alternate"
-                  href="${branch.url(['revision', entry.revid ])}" />
+	    <link rel="alternate" href="${tg.url([ external_url, branch.group_name, branch.name, 'revision', entry.revid ])}" />
 	</entry>
 </feed>

=== modified file 'loggerhead/templates/browse.kid'
--- loggerhead/templates/browse.kid	2008-02-27 01:55:39 +0000
+++ loggerhead/templates/browse.kid	2007-01-21 00:05:52 +0000
@@ -34,7 +34,7 @@
             <tr>
             <td class="name"> <a href="${tg.url([ '/' + project.name, view.name ])}">${view.friendly_name}</a> </td>
             <td class="description"> ${view.description} </td>
-            <td class="last-update"> ${view.get_history().has_revisions and util.ago(view.last_updated()) or "(no revisions)"} </td>
+            <td class="last-update"> ${util.ago(view.last_updated())} </td>
             <td class="feed">
                 <a href="${tg.url([ '/' + project.name, view.name, 'atom' ])}" title="atom feed">
                     <img src="${tg.url('/static/images/feed-icon-16x16.gif')}" alt="atom feed" />

=== modified file 'loggerhead/templates/changelog.kid'
--- loggerhead/templates/changelog.kid	2007-09-04 17:21:59 +0000
+++ loggerhead/templates/changelog.kid	2007-01-21 00:05:52 +0000
@@ -14,22 +14,7 @@
         <a href="${branch.url([ '/annotate', revid ], **util.get_context(file_id=file_id))}" title="Annotate ${filename}">${filename}</a>
     </span>
     
-    <span py:def="file_diff_link(revid, filename)">
-        <a href="javascript:diff_url('${branch.context_url([ '/revision', revid ]) + '#' + filename}')"
-           title="View diff for ${filename}">${filename}</a>
-    </span>
-    
     ${use_collapse_buttons()}
-
-    <script type="text/javascript"> <!--
-    function diff_url(url) {
-        if (document.cookie.indexOf('diff=unified') >= 0) {
-            this.location.href = url + "-u";
-        } else {
-            this.location.href = url + "-s";
-        }
-    }
-    // --> </script>
 </head>
 
 <body onload="javascript:sortCollapseElements();">
@@ -46,99 +31,85 @@
     Sorry, no results found for your search.
 </span>
 
-<span py:if="not changes">
-    No revisions!
-</span>
-
 <span py:if="not search_failed" class="changelog"> ${collapse_all_button('cl')} </span>
 
-<table class="log-entries">
-    <tr class="log-header">
-        <th class="revision-number">Rev</th>
-        <th></th>
-        <th class="summary">Summary</th>
-        <span py:strip="True" py:if="all_same_author">
-            <th></th>
-        </span>
-        <span py:strip="True" py:if="not all_same_author">
-            <th class="author">Committer</th>
-        </span>
-        <th class="date" colspan="2">Date</th>
-    </tr>
+<div class="log-entries">
     <div py:for="entry in changes" class="revision">
         <a name="entry-${entry.revno}" />
-        <tr class="revision-header parity${entry.parity}">
-            <td class="revision-number"> ${revision_link(entry.revid, util.trunc(entry.revno))} </td>
-            <td class="expand-button"> ${collapse_button('cl', entry.revno)} </td>
-            <td class="summary"> ${revision_link(entry.revid, entry.short_comment)} </td>
-            <span py:strip="True" py:if="all_same_author">
-                <td></td>
-            </span>
-            <span py:strip="True" py:if="not all_same_author">
-                <td class="author"> ${util.trunc(util.hide_email(entry.author), 20)} </td>
-            </span>
-            <td class="date"> ${util.format_date(entry.date)} &nbsp; (${util.ago(entry.date)}) </td>
-            <td class="inventory-link"> 
-                <a href="${branch.url([ '/files', entry.revid ])}"
-                    title="Files at revision ${entry.revno}"> files</a>
-            </td>
-        </tr>
+        <div class="revision-header">
+            <table>
+                <tr>
+                    <td class="revision-number"> ${revision_link(entry.revid, util.trunc(entry.revno))} </td>
+                    <td class="expand-button"> ${collapse_button('cl', entry.revno)} </td>
+					<td class="summary"> ${revision_link(entry.revid, entry.short_comment)} </td>
+					<td class="inventory-link"> <a href="${branch.url([ '/files', entry.revid ])}">&#8594; files</a> </td>
+				</tr>
+			</table>
+        </div>
         
-        <tr class="revision-details-block parity${entry.parity}">
-            <td colspan="2"></td>
-            <td colspan="4"><table class="revision-details hidden-details collapse-cl-${entry.revno}-content">
-                <tr py:if="len(entry.merge_points) > 0">
-                    <th class="children"> merged in: </th>
-                    <td class="children">
-                        <span py:for="child in entry.merge_points">
-                            ${loglink(child.revid, '(' + child.revno + util.if_present(' %s', child.branch_nick) + ')')} <br />
-                        </span>
-                    </td>
-                </tr>
-                <tr py:if="len(entry.parents) > 1">
-                    <th class="parents"> merged from: </th>
-                    <td class="parents">
-                        <span py:for="parent in entry.parents[1:]">
-                            ${loglink(parent.revid, parent.revno + util.if_present(' (%s)', parent.branch_nick))} <br />
-                        </span>
-                    </td>
-                </tr>
-                <span py:strip="True" py:if="all_same_author">
-                    <tr>
-                        <th class="author">committed by:</th>
-                        <td class="author"> ${util.hide_email(entry.author)} </td>
-                    </tr>
-                </span>
-                <tr>
-                    <th class="description">description:</th>
-                    <td class="description"><span py:for="line in entry.comment_clean">${XML(line)} <br /></span> </td>
-                </tr>
-                <tr py:if="entry.changes.added">
-                    <th class="files"> files added: </th>
-                    <td class="files"> <span py:for="filename, fid in entry.changes.added" class="filename">${file_link(filename, fid, entry.revid)} <br /></span> </td>
-                </tr>
-                <tr py:if="entry.changes.removed">
-                    <th class="files"> files removed: </th>
-                    <td class="files"> <span py:for="filename, fid in entry.changes.removed" class="filename">${file_link(filename, fid, entry.revid)} <br /></span> </td>
-                </tr>
-                <tr py:if="entry.changes.renamed">
-                    <th class="files"> files renamed: </th>
-                    <td class="files"> <span py:for="old_filename, new_filename, fid in entry.changes.renamed" class="filename">
-                        ${file_link(old_filename, fid, entry.revid)} => ${file_link(new_filename, fid, entry.revid)}<br />
-                    </span> </td>
-                </tr>
-                <tr py:if="entry.changes.modified">
-                    <th class="files"> files modified: </th>
-                    <td class="files"> <span py:for="item in entry.changes.modified">
-                        <span class="filename">${file_diff_link(entry.revid, item.filename)}</span>
-                        <br />
-                    </span> </td>
-                </tr>
-                </table>
-            </td>
-        </tr>
+        <div class="revision-details-block">
+            <div class="revision-details">
+			    <table>
+			        <tr>
+			            <th class="author">committed by:</th>
+			            <td class="author"> ${util.hide_email(entry.author)} </td>
+			        </tr>
+			        <tr>
+			            <th class="date">date:</th>
+			            <td class="date"> ${entry.date.strftime('%d %b %Y %H:%M')} &nbsp; (${util.ago(entry.date)}) </td>
+			        </tr>
+			    </table>
+			</div>
+	        <div class="revision-details hidden-details collapse-cl-${entry.revno}-content">
+		        <table>
+			        <tr py:if="len(entry.merge_points) > 0">
+			            <th class="children"> merged in: </th>
+			            <td class="children">
+			                <span py:for="child in entry.merge_points">
+			                    ${loglink(child.revid, '(' + child.revno + util.if_present(' %s', child.branch_nick) + ')')} <br />
+			                </span>
+			            </td>
+			        </tr>
+			        <tr py:if="len(entry.parents) > 1">
+			        	<th class="parents"> merged from: </th>
+			        	<td class="parents">
+			        	    <span py:for="parent in entry.parents"><span py:if="parent.revid != entry.parents[0].revid">
+			        	        ${loglink(parent.revid, '(' + parent.revno + util.if_present(' %s', parent.branch_nick) + ')')} <br />
+			        	    </span></span>
+			        	</td>
+			        </tr>
+
+			        <tr py:if="entry.changes.added">
+			            <th class="files"> files added: </th>
+			            <td class="files"> <span py:for="filename, fid in entry.changes.added" class="filename">${file_link(filename, fid, entry.revid)} <br /></span> </td>
+			        </tr>
+			        <tr py:if="entry.changes.removed">
+			            <th class="files"> files removed: </th>
+			            <td class="files"> <span py:for="filename, fid in entry.changes.removed" class="filename">${file_link(filename, fid, entry.revid)} <br /></span> </td>
+			        </tr>
+			        <tr py:if="entry.changes.renamed">
+			            <th class="files"> files renamed: </th>
+			            <td class="files"> <span py:for="old_filename, new_filename, fid in entry.changes.renamed" class="filename">
+			                ${file_link(old_filename, fid, entry.revid)} => ${file_link(new_filename, fid, entry.revid)}<br />
+			            </span> </td>
+			        </tr>
+			        <tr py:if="entry.changes.modified">
+			            <th class="files"> files modified: </th>
+			            <td class="files"> <span py:for="item in entry.changes.modified">
+			                <span class="filename">${file_link(item.filename, item.file_id, entry.revid)}</span> &nbsp;
+			                <a href="${branch.url([ '/revision', entry.revid ], **util.get_context()) + '#' + item.filename}" class="jump">&#8594; diff</a>
+			                <br />
+			            </span> </td>
+			        </tr>
+			        <tr>
+			            <th class="description">description:</th>
+		                <td class="description"><span py:for="line in entry.comment_clean">${XML(line)} <br /></span> </td>
+		            </tr>
+		        </table>
+	    	</div>
+        </div>
     </div>
-</table>
+</div>
 
 <div py:if="navigation.prev_page_revid or navigation.next_page_revid" class="bar">
     <table>

=== modified file 'loggerhead/templates/inventory.kid'
--- loggerhead/templates/inventory.kid	2007-09-04 17:06:03 +0000
+++ loggerhead/templates/inventory.kid	2007-01-24 19:26:50 +0000
@@ -12,9 +12,9 @@
 
 <h1> <span class="branch-name">${branch.friendly_name}</span> : files for revision ${change.revno}
 	<div class="links">
-	    <div> <b>&#8594;</b> <a href="${branch.context_url('/revision', clear=1, start_revid=revid)}">
+	    <div> <b>&#8594;</b> <a href="${branch.url('/revision', **util.get_context(clear=1, start_revid=revid))}">
 	        view revision </a> </div>
-	    <div> <b>&#8594;</b> <a href="${branch.context_url('/changes', clear=1, start_revid=revid)}">
+	    <div> <b>&#8594;</b> <a href="${branch.url('/changes', **util.get_context(clear=1, start_revid=revid))}">
 	        view branch changes </a> </div>
 	</div>
 </h1>
@@ -28,7 +28,7 @@
         </tr>
         <tr>
             <th class="date">date:</th>
-            <td class="date"> ${util.format_date(change.date)} </td>
+            <td class="date"> ${change.date.strftime('%d %b %Y %H:%M')} </td>
         </tr>
 
         <tr py:if="len(change.merge_points) > 0">
@@ -62,39 +62,40 @@
 <table class="inventory" width="100%">
     <tr class="header">
         <th class="permissions"> Permissions </th>
-        <th> <a href="${branch.context_url([ '/files', revid ], sort='filename')}">Filename</a> </th>
-        <th> Latest Rev </th>
-        <th> <a href="${branch.context_url([ '/files', revid ], sort='date')}">Last Changed</a> </th>
-        <th> <a href="${branch.context_url([ '/files', revid ], sort='size')}">Size</a> </th>
-        <th>  </th>
-        <th>  </th>
+        <th> <a href="${branch.url([ '/files', revid ], **util.get_context(sort='filename'))}">Filename</a> </th>
+        <th> <a href="${branch.url([ '/files', revid ], **util.get_context(sort='size'))}">Size</a> </th>
+        <th> Last change </th>
+        <th> <a href="${branch.url([ '/files', revid ], **util.get_context(sort='date'))}">When</a> </th>
+        <th> History </th>
+        <th> Download </th>
     </tr>
     
     <tr class="parity1" py:if="updir">
         <td class="permissions">drwxr-xr-x</td>
-        <td class="filename directory"><a href="${branch.context_url([ '/files', revid ], file_id=updir_file_id)}"> (up) </a></td>
+        <td class="filename directory"><a href="${branch.url([ '/files', revid ],
+            **util.get_context(file_id=updir_file_id))}"> (up) </a></td>
         <td> </td> <td> </td> <td> </td> <td> </td>
     </tr>
 
     <tr py:for="file in filelist" class="parity${file.parity}">
         <td class="permissions"> ${util.fake_permissions(file.kind, file.executable)} </td>
         <td class="filename ${file.kind}">
-            <a py:if="file.kind=='directory'" href="${branch.context_url([ '/files', revid ],
-                file_id=file.file_id)}">${file.filename}/</a>
+            <a py:if="file.kind=='directory'" href="${branch.url([ '/files', revid ],
+                **util.get_context(file_id=file.file_id))}">${file.filename}/</a>
             <span py:if="file.kind=='symlink'">${file.filename}@</span>
-            <a py:if="file.kind=='file'" href="${branch.context_url([ '/annotate', revid ],
-                file_id=file.file_id)}" title="Annotate ${file.filename}">${file.filename}</a>
+            <a py:if="file.kind=='file'" href="${branch.url([ '/annotate', revid ],
+                **util.get_context(file_id=file.file_id))}" title="Annotate ${file.filename}">${file.filename}</a>
         </td>
+        <td class="size"> <span py:if="file.kind=='file'"> ${util.human_size(file.size)} </span></td>
         <td class="revision"> ${revision_link(file.revid, util.trunc(file.change.revno, 15), **util.get_context(start_revid=file.revid, file_id=file.file_id))} </td>
-        <td class="date"> ${util.format_date(file.change.date)} </td>
-        <td class="size"> <span py:if="file.kind=='file'"> ${util.human_size(file.size)} </span></td>
+        <td class="date"> ${file.change.date.strftime('%d %b %Y %H:%M')} </td>
         <td class="changes-link"> 
-            <a href="${branch.context_url('/changes', start_revid=file.revid, file_id=file.file_id)}"
-               title="Changes affecting ${file.filename} up to revision ${file.change.revno}"> changes </a>
+            <a href="${branch.url('/changes', **util.get_context(start_revid=file.revid, file_id=file.file_id))}"
+               title="Changes from ${file.change.revno} affecting ${file.filename}"> &#8594; changes </a>
         </td>
         <td class="download-link">
             <a href="${branch.url([ '/download', file.revid, file.file_id, file.filename ])}"
-               title="Download ${file.filename} at revision ${file.change.revno}">  download </a></td>
+               title="Download ${file.filename} at revision ${file.change.revno}"> &#8594; download </a></td>
     </tr>
 </table>
 

=== modified file 'loggerhead/templates/master.kid'
--- loggerhead/templates/master.kid	2007-09-02 22:54:43 +0000
+++ loggerhead/templates/master.kid	2007-01-24 19:17:40 +0000
@@ -19,8 +19,8 @@
               file_id=getattr(navigation, 'file_id', None))}"><table><tr>
             <td><span class="buttons">
                 <!-- ! navbar buttons never change, from now on.  i decree it! -->
-                <a href="${branch.context_url('/changes', clear=1)}"> changes </a>
-                <a href="${branch.context_url('/files', clear=1)}"> files </a>
+                <a href="${branch.url('/changes', **util.get_context(clear=1))}"> changes </a>
+                <a href="${branch.url('/files', **util.get_context(clear=1))}"> files </a>
                 <span class="search"> search: <input type="text" name="q" /> </span>
             </span></td>
             <td align="right" py:if="hasattr(navigation, 'revid_list')">
@@ -34,7 +34,8 @@
                     </span>
                 	<span py:if="not navigation.prev_page_revid"> &#171; </span>
                     revision ${history.get_revno(revid)}
-                    (<span py:if="navigation.pagesize > 1">page </span>${navigation.page_position} / ${navigation.page_count})
+                    (<span py:if="navigation.pagesize > 1">page </span>
+                    ${navigation.page_position} / ${navigation.page_count})
                 	<span py:if="navigation.next_page_revid">
                     <a href="${navigation.next_page_url}" title="Next page"> &#187; </a>
                     </span>

=== modified file 'loggerhead/templates/revision.kid'
--- loggerhead/templates/revision.kid	2007-09-04 17:06:03 +0000
+++ loggerhead/templates/revision.kid	2007-01-24 19:26:50 +0000
@@ -9,41 +9,28 @@
         <a href="${branch.url([ '/annotate', revid ],
             **util.get_context(file_id=file_id))}" title="Annotate ${filename}">${filename}</a>
     </span>
-    <span py:strip="True" py:def="file_link_rev(filename, file_id, revid)">
-        <a href="${branch.url([ '/annotate', revid ],
-            **util.get_context(file_id=file_id))}" title="Annotate ${filename} at revision ${history.get_revno(revid)}">${filename}</a>
-    </span>
     
     <span py:replace="use_collapse_buttons()"></span>
     
     <script type="text/javascript"> <!--
-    function show_sbs(path) {
+    function show_sbs() {
         collapseDisplay('style', 'sbs', 'table');
         collapseDisplay('style', 'unified', 'none');
-        document.cookie='diff=sbs; path=' + path; 
+        document.cookie='diff=sbs';
     }
-    function show_unified(path) {
+    function show_unified() {
         collapseDisplay('style', 'unified', 'table');
         collapseDisplay('style', 'sbs', 'none');
-        document.cookie='diff=unified; path=' + path; 
+        document.cookie='diff=unified'; 
     }
-    function load(path) {
+    function load() {
         sortCollapseElements();
-        if (document.cookie.indexOf('diff=unified') >= 0) {
-            show_unified(path);
-        }
-        if (document.cookie.indexOf('stop=1') >= 0) {
-            return;
-        }
-        if (document.cookie.indexOf('diff=unified') >= 0) {
-            window.location.hash = window.location.hash;
-            document.cookie='stop=1; max-age=5; path=' + window.location.pathname;
-        } 
+        if (document.cookie.indexOf('diff=unified') >= 0) { show_unified(); }
     }
     // --> </script>
 </head>
 
-<body onload="javascript:load('${branch.url('/')}')">
+<body onload="javascript:load()">
 
 ${navbar()}
 
@@ -51,27 +38,32 @@
     <span py:if="compare_revid is not None"> (compared to revision ${history.get_revno(compare_revid)}) </span>
     
     <div class="links">
-        <div> <b>&#8594;</b> <a href="${branch.context_url([ '/files', revid ])}">
-            browse files at revision ${change.revno} </a> </div>
-        <div> <b>&#8594;</b> <a href="${branch.context_url('/changes', start_revid=revid)}">
-            view history from revision ${change.revno} </a> </div>
+        <div> <b>&#8594;</b> <a href="${branch.url([ '/files', revid ], **util.get_context())}">
+            browse files</a> </div>
+        <div> <b>&#8594;</b> <a href="${branch.url('/changes', **util.get_context(start_revid=revid))}">
+            view branch changes</a> </div>
+        <span py:if="compare_revid is None" py:strip="True">
+            <div> <b>&#8594;</b> <a href="${branch.url([ '/bundle', revid, 'bundle.txt' ])}">
+                view/download patch</a> </div>
+        </span>
         <span py:if="compare_revid is not None" py:strip="True">
             <div> <b>&#8594;</b> <a href="${branch.url([ '/bundle', revid, compare_revid, 'bundle.txt' ])}">
-                download bundle from ${history.get_revno(compare_revid)} to ${change.revno} </a> </div>
+                view/download patch</a> </div>
         </span>
-        <span py:if="(remember is not None) and (compare_revid is None) and (revid != remember)" py:strip="True">
-            <div> <b>&#8594;</b> <a href="${branch.context_url([ '/revision', revid ], compare_revid=remember)}">
+        <span py:if="(remember is not None) and (compare_revid is None)" py:strip="True">
+            <div> <b>&#8594;</b> <a href="${branch.url([ '/revision', revid ],
+                **util.get_context(compare_revid=remember))}">
                 compare with revision ${history.get_revno(remember)} </a></div>
         </span>
         <span py:if="remember != revid" py:strip="True">
-            <div> <b>&#8594;</b> <a href="${branch.context_url([ '/revision', revid ], remember=revid, compare_revid=None)}">
+            <div> <b>&#8594;</b> <a href="${branch.url([ '/revision', revid ],
+                **util.get_context(remember=revid, compare_revid=None))}">
                 compare with another revision </a></div>
         </span>
         <span py:if="compare_revid is not None" py:strip="True">
-            <div> <b>&#8594;</b> <a href="${branch.context_url([ '/revision', compare_revid ], remember=revid, compare_revid=revid)}">
-                reverse the comparison (${change.revno} to ${history.get_revno(compare_revid)})</a></div>
-            <div> <b>&#8594;</b> <a href="${branch.context_url([ '/revision', revid ], remember=None, compare_revid=None)}">
-                stop comparing with revision ${history.get_revno(compare_revid)} </a></div>
+            <div> <b>&#8594;</b> <a href="${branch.url([ '/revision', revid ],
+                **util.get_context(remember=None, compare_revid=None))}">
+                stop comparing to revision ${history.get_revno(compare_revid)} </a></div>
         </span>
     </div>
 </h1>
@@ -84,7 +76,7 @@
         </tr>
         <tr>
             <th class="date">date:</th>
-            <td class="date"> ${util.format_date(change.date)} </td>
+            <td class="date"> ${change.date.strftime('%d %b %Y %H:%M')} </td>
         </tr>
 
         <tr py:if="len(change.merge_points) > 0">
@@ -117,9 +109,7 @@
         </tr>
         <tr py:if="change.changes.removed">
             <th class="files"> files removed: </th>
-            <td class="files"> <span py:for="filename, file_id in change.changes.removed" class="filename">
-                ${file_link_rev(filename, file_id, change.parents[0].revid)} <br /></span>
-            </td>
+            <td class="files"> <span py:for="filename, file_id in change.changes.removed" class="filename">${file_link(filename, file_id)} <br /></span> </td>
         </tr>
         <tr py:if="change.changes.renamed">
             <th class="files"> files renamed: </th>
@@ -130,11 +120,8 @@
         <tr py:if="change.changes.modified">
             <th class="files"> files modified: </th>
             <td class="files">
-                <span py:for="item in change.changes.modified" class="collapse-style-sbs-content">
-                    <a href="#${item.filename}-s" class="filename" title="Jump to ${item.filename} below">${item.filename}</a><br />
-                </span>
-                <span py:for="item in change.changes.modified" class="collapse-style-unified-content">
-                    <a href="#${item.filename}-u" class="filename" title="Jump to ${item.filename} below">${item.filename}</a><br />
+                <span py:for="item in change.changes.modified">
+                    <span class="filename">${file_link(item.filename, item.file_id)}</span> &nbsp; <a href="#${item.filename}" class="jump">&#8594; diff</a><br />
                 </span>
             </td>
         </tr>
@@ -146,9 +133,9 @@
     <td> ${collapse_all_button('file', 'table-row')} </td>
 
     <td class="spacey">
-        <a href="javascript:show_sbs('${branch.url('/')}')" class="hide-all collapse-style-sbs-show" title="collapse">
+        <a href="javascript:show_sbs()" class="hide-all collapse-style-sbs-show" title="collapse">
             <img src="${tg.url('/static/images/nav-small-out.gif')}" width="22" height="10" class="collapse-triangle" />show side by side</a>
-        <a href="javascript:show_unified('${branch.url('/')}')" class="hide-all collapse-style-unified-show" title="expand">
+        <a href="javascript:show_unified()" class="hide-all collapse-style-unified-show" title="expand">
             <img src="${tg.url('/static/images/nav-small-in.gif')}" width="22" height="10" class="collapse-triangle" />show unified diff</a>
     </td>
     
@@ -168,8 +155,7 @@
         <span py:strip="True" py:for="item in change.changes.modified">
             <tr><th class="filename" colspan="4">
                 ${collapse_button('file', util.uniq(uniqs, item.file_id), 'table-row')}
-                <a href="${branch.url([ '/annotate', change.revid ], **util.get_context(file_id=item.file_id))}"
-                    name="${item.filename}-s" title="Annotate ${item.filename}">${item.filename}</a>
+                <a href="${branch.url([ '/annotate', change.revid ], **util.get_context(file_id=item.file_id))}" name="${item.filename}">${item.filename}</a>
             </th></tr>
 
             <span py:strip="True" py:for="chunk in item.sbs_chunks">
@@ -179,19 +165,19 @@
                 <tr py:for="line in chunk.diff" class="diff-chunk collapse-file-${util.uniq(uniqs, item.file_id)}-content">
                     <span py:if="line.old_lineno" py:strip="True">
                         <td class="lineno">${line.old_lineno}</td>
-                        <td class="diff-${line.old_type}">${line.old_line}</td>
+                        <td class="diff-${line.old_type}">${XML(line.old_line)}</td>
                     </span>
                     <span py:if="not line.old_lineno" py:strip="True">
                         <td class="lineno-skip">${line.old_lineno}</td>
-                        <td class="diff-${line.old_type}-skip">${line.old_line}</td>
+                        <td class="diff-${line.old_type}-skip">${XML(line.old_line)}</td>
                     </span>
                     <span py:if="line.new_lineno" py:strip="True">
                         <td py:if="line.new_lineno" class="lineno">${line.new_lineno}</td>
-                        <td class="diff-${line.new_type}">${line.new_line}</td>
+                        <td class="diff-${line.new_type}">${XML(line.new_line)}</td>
                     </span>
                     <span py:if="not line.new_lineno" py:strip="True">
                         <td py:if="not line.new_lineno" class="lineno-skip">${line.new_lineno}</td>
-                        <td class="diff-${line.new_type}-skip">${line.new_line}</td>
+                        <td class="diff-${line.new_type}-skip">${XML(line.new_line)}</td>
                     </span>
                 </tr>
                 <tr class="diff-chunk-spacing collapse-file-${util.uniq(uniqs, item.file_id)}-content"> <td colspan="4"> &nbsp; </td> </tr>
@@ -202,25 +188,24 @@
     
     <!-- ! unified diff -->
     <table class="diff-block collapse-style-unified-content">
-        <span py:strip="True" py:for="item in change.changes.modified">
-            <tr><th class="filename" colspan="4">
-                ${collapse_button('file', util.uniq(uniqs, item.file_id), 'table-row')}
-                <a href="${branch.url([ '/annotate', change.revid ], **util.get_context(file_id=item.file_id))}"
-                    name="${item.filename}-u" title="Annotate ${item.filename}">${item.filename}</a>
-            </th></tr>
-
-            <span py:strip="True" py:for="chunk in item.chunks">
-                <tr class="diff-chunk collapse-file-${util.uniq(uniqs, item.file_id)}-content"> <th class="lineno">old</th> <th class="lineno">new</th> <th></th> <th></th> </tr>
-                <tr py:for="line in chunk.diff" class="diff-chunk collapse-file-${util.uniq(uniqs, item.file_id)}-content">
-                    <td class="lineno">${line.old_lineno}</td>
-                    <td class="lineno">${line.new_lineno}</td>
-                    <td class="diff-${line.type} text">${line.line}</td>
-                    <td> </td>
-                </tr>
-                <tr class="diff-chunk-spacing collapse-file-${util.uniq(uniqs, item.file_id)}-content"> <td colspan="4"> &nbsp; </td> </tr>
-            </span>
-            <tr class="diff-spacing"> <td colspan="4"> &nbsp; </td> </tr>
-        </span>
+	    <span py:strip="True" py:for="item in change.changes.modified">
+	        <tr><th class="filename" colspan="4">
+	            ${collapse_button('file', util.uniq(uniqs, item.file_id), 'table-row')}
+	            <a href="${branch.url([ '/annotate', change.revid ], **util.get_context(file_id=item.file_id))}" name="${item.filename}">${item.filename}</a>
+	        </th></tr>
+	
+	        <span py:strip="True" py:for="chunk in item.chunks">
+	            <tr class="diff-chunk collapse-file-${util.uniq(uniqs, item.file_id)}-content"> <th class="lineno">old</th> <th class="lineno">new</th> <th></th> <th></th> </tr>
+	            <tr py:for="line in chunk.diff" class="diff-chunk collapse-file-${util.uniq(uniqs, item.file_id)}-content">
+	                <td class="lineno">${line.old_lineno}</td>
+	                <td class="lineno">${line.new_lineno}</td>
+	                <td class="diff-${line.type} text">${XML(line.line)}</td>
+	                <td> </td>
+	            </tr>
+	            <tr class="diff-chunk-spacing collapse-file-${util.uniq(uniqs, item.file_id)}-content"> <td colspan="4"> &nbsp; </td> </tr>
+	        </span>
+	        <tr class="diff-spacing"> <td colspan="4"> &nbsp; </td> </tr>
+	    </span>
     </table>
 
 </div>

=== added file 'loggerhead/tests/test_controllers.py'
--- loggerhead/tests/test_controllers.py	1970-01-01 00:00:00 +0000
+++ loggerhead/tests/test_controllers.py	2006-12-11 06:44:19 +0000
@@ -0,0 +1,16 @@
+from turbogears import testutil
+from loggerhead.controllers import Root
+import cherrypy
+
+cherrypy.root = Root()
+
+def test_method():
+    "the index method should return a string called now"
+    import types
+    result = testutil.call(cherrypy.root.index)
+    assert type(result["now"]) == types.StringType
+
+def test_indextitle():
+    "The mainpage should have the right title"
+    testutil.createRequest("/")
+    assert "<TITLE>Welcome to TurboGears</TITLE>" in cherrypy.response.body[0]

=== removed file 'loggerhead/tests/test_corners.py'
--- loggerhead/tests/test_corners.py	2007-09-10 13:43:45 +0000
+++ loggerhead/tests/test_corners.py	1970-01-01 00:00:00 +0000
@@ -1,95 +0,0 @@
-import os
-
-import cherrypy
-from turbogears import testutil
-
-from loggerhead.tests.test_simple import BasicTests
-
-class TestCornerCases(BasicTests):
-    """Tests that excercise various corner cases."""
-
-    def addFileAndCommit(self, filename, commit_msg):
-        """Make a trivial commit that has 'msg' as its commit message.
-
-        The commit adds a file called 'myfilename' containing the string
-        'foo'.
-        """
-        f = open(os.path.join(self.bzrbranch, filename), 'w')
-        try:
-            f.write("foo")
-        finally:
-            f.close()
-        self.tree.add(filename)
-        self.tree.commit(message=commit_msg)
-
-
-    def test_survive_over_upgrade(self):
-        """Check that running 'bzr upgrade' on a branch does not break an
-        instance of loggerhead that's already looked at it.
-        """
-        self.createBranch()
-
-        msg = 'a very exciting commit message'
-        self.addFileAndCommit('myfilename', msg)
-
-        self.setUpLoggerhead()
-
-        testutil.create_request('/project/branch/changes')
-        assert msg in cherrypy.response.body[0]
-
-        from bzrlib.upgrade import upgrade
-        from bzrlib.bzrdir import format_registry
-        upgrade(self.bzrbranch, format_registry.make_bzrdir('dirstate-tags'))
-
-        testutil.create_request('/project/branch/changes')
-        assert msg in cherrypy.response.body[0]
-
-
-    def test_revision_only_changing_execute_bit(self):
-        """Check that a commit that only changes the execute bit of a file
-        does not break the rendering."""
-        self.createBranch()
-
-        # Just a commit to have a file to change the execute bit of.
-        msg = 'a very exciting commit message'
-        self.addFileAndCommit('myfilename', msg)
-
-        # Make a commit that changes the execute bit of 'myfilename'.
-        os.chmod(os.path.join(self.bzrbranch, 'myfilename'), 0755)
-        newrevid = self.tree.commit(message='make something executable')
-
-        # Check that it didn't break things.
-        self.setUpLoggerhead()
-        testutil.create_request('/project/branch/revision/'+newrevid)
-        assert 'executable' in cherrypy.response.body[0]
-
-
-    def test_empty_commit_message(self):
-        """Check that an empty commit message does not break the rendering."""
-        self.createBranch()
-
-        # Make a commit that has an empty message.
-        self.addFileAndCommit('myfilename', '')
-
-        # Check that it didn't break things.
-        self.setUpLoggerhead()
-        testutil.create_request('/project/branch/changes')
-        # It's not much of an assertion, but we only really care about
-        # "assert not crashed".
-        assert 'myfilename' in cherrypy.response.body[0]
-
-
-    def test_whitespace_only_commit_message(self):
-        """Check that a whitespace-only commit message does not break the
-        rendering."""
-        self.createBranch()
-
-        # Make a commit that has a whitespace only message.
-        self.addFileAndCommit('myfilename', '   ')
-
-        # Check that it didn't break things.
-        self.setUpLoggerhead()
-        testutil.create_request('/project/branch/changes')
-        # It's not much of an assertion, but we only really care about
-        # "assert not crashed".
-        assert 'myfilename' in cherrypy.response.body[0]

=== removed file 'loggerhead/tests/test_filechangecache.py'
--- loggerhead/tests/test_filechangecache.py	2007-09-10 12:51:42 +0000
+++ loggerhead/tests/test_filechangecache.py	1970-01-01 00:00:00 +0000
@@ -1,95 +0,0 @@
-"""Tests for the FileChangeCache in loggerhead.changecache."""
-
-import shutil
-import tempfile
-
-from loggerhead.changecache import FileChangeCache
-
-class MockEntry:
-    def __init__(self, revid):
-        self.revid = revid
-
-
-class MockHistory:
-    def __init__(self):
-        self.fetched_revids = set()
-    def get_file_changes_uncached(self, entries):
-        output = []
-        for entry in entries:
-            self.fetched_revids.add(entry.revid)
-            output.append(entry.revid)
-        return output
-
-
-class TestFileChangeCache(object):
-
-    # setup_method and teardown_method are so i can run the tests with
-    # py.test and take advantage of the error reporting.
-    def setup_method(self, meth):
-        self.setUp()
-
-    def teardown_method(self, meth):
-        self.tearDown()
-
-    def setUp(self):
-        self.cache_folders = []
-
-    def tearDown(self):
-        for folder in self.cache_folders:
-            shutil.rmtree(folder)
-
-
-    def makeHistoryAndEntriesForRevids(self, revids, fill_cache_with=[]):
-        cache_folder = tempfile.mkdtemp()
-        self.cache_folders.append(cache_folder)
-        self.history = MockHistory()
-        self.cache = FileChangeCache(self.history, cache_folder)
-
-        self.entries = [MockEntry(revid) for revid in revids]
-
-        self.cache.get_file_changes([entry for entry in self.entries
-                                     if entry.revid in fill_cache_with])
-        self.history.fetched_revids.clear()
-
-
-    def test_empty_cache(self):
-        """An empty cache passes all the revids through to the history object.
-        """
-        revids = ['a', 'b']
-        self.makeHistoryAndEntriesForRevids(revids)
-
-        result = self.cache.get_file_changes(self.entries)
-
-        assert result == revids
-        assert self.history.fetched_revids == set(revids)
-
-    def test_full_cache(self):
-        """A full cache passes none of the revids through to the history
-        object.
-        """
-        revids = ['a', 'b']
-        self.makeHistoryAndEntriesForRevids(revids, fill_cache_with=revids)
-
-        result = self.cache.get_file_changes(self.entries)
-
-        assert result == revids
-        assert self.history.fetched_revids == set()
-
-    def test_partial_cache(self):
-        """A partially full cache passes some of the revids through to the
-        history object, and preserves the ordering of the argument list.
-        """
-        # To test the preservation of argument order code, we put the uncached
-        # revid at the beginning, middle and then end of the list of revids
-        # being asked for.
-        for i in range(3):
-            cached_revids = ['a', 'b']
-            revids = cached_revids[:]
-            revids.insert(i, 'uncached')
-            self.makeHistoryAndEntriesForRevids(
-                revids, fill_cache_with=cached_revids)
-
-            result = self.cache.get_file_changes(self.entries)
-            assert result == revids
-
-            assert self.history.fetched_revids == set(['uncached'])

=== added file 'loggerhead/tests/test_model.py'
--- loggerhead/tests/test_model.py	1970-01-01 00:00:00 +0000
+++ loggerhead/tests/test_model.py	2006-12-11 06:44:19 +0000
@@ -0,0 +1,22 @@
+# If your project uses a database, you can set up database tests
+# similar to what you see below. Be sure to set the db_uri to
+# an appropriate uri for your testing database. sqlite is a good
+# choice for testing, because you can use an in-memory database
+# which is very fast.
+
+from turbogears import testutil, database
+# from loggerhead.model import YourDataClass, User
+
+# database.set_db_uri("sqlite:///:memory:")
+
+# class TestUser(testutil.DBTest):
+#     def get_model(self):
+#         return User
+#     def test_creation(self):
+#         "Object creation should set the name"
+#         obj = User(user_name = "creosote",
+#                       email_address = "spam@python.not",
+#                       display_name = "Mr Creosote",
+#                       password = "Wafer-thin Mint")
+#         assert obj.display_name == "Mr Creosote"
+

=== removed file 'loggerhead/tests/test_simple.py'
--- loggerhead/tests/test_simple.py	2008-02-27 02:41:36 +0000
+++ loggerhead/tests/test_simple.py	1970-01-01 00:00:00 +0000
@@ -1,146 +0,0 @@
-from configobj import ConfigObj
-import cgi
-import unittest
-import os
-import tempfile
-import shutil
-import logging
-
-import cherrypy
-from turbogears import testutil
-
-import bzrlib
-
-from loggerhead.controllers import Root
-
-def test_simple():
-    config = ConfigObj()
-    r = Root(config)
-    cherrypy.root = r
-    testutil.create_request('/')
-    assert 'loggerhead branches' in cherrypy.response.body[0]
-
-
-class BasicTests(object):
-
-    # setup_method and teardown_method are so i can run the tests with
-    # py.test and take advantage of the error reporting.
-    def setup_method(self, meth):
-        self.setUp()
-
-    def teardown_method(self, meth):
-        self.tearDown()
-
-    def setUp(self):
-        #logging.basicConfig(level=logging.DEBUG)
-        self.bzrbranch = None
-        self.old_bzrhome = None
-
-    def createBranch(self):
-        self.old_bzrhome = bzrlib.osutils.set_or_unset_env('BZR_HOME', '')
-        self.bzrbranch = tempfile.mkdtemp()
-        self.branch = bzrlib.bzrdir.BzrDir.create_branch_convenience(
-            self.bzrbranch, force_new_tree=True)
-        self.tree = self.branch.bzrdir.open_workingtree()
-
-    config_template = """
-    [project]
-        [[branch]]
-            branch_name = 'branch'
-            folder = '%(branch)s'
-    """
-
-    def setUpLoggerhead(self):
-        ini = self.config_template%dict(branch=self.bzrbranch)
-
-        config = ConfigObj(ini.splitlines())
-        cherrypy.root = Root(config)
-
-    def tearDown(self):
-        if self.bzrbranch is not None:
-            shutil.rmtree(self.bzrbranch)
-        bzrlib.osutils.set_or_unset_env('BZR_HOME', self.old_bzrhome)
-
-class TestWithSimpleTree(BasicTests):
-
-    def setUp(self):
-        BasicTests.setUp(self)
-        self.createBranch()
-
-        f = open(os.path.join(self.bzrbranch, 'myfilename'), 'w')
-        self.filecontents = ('some\nmultiline\ndata\n'
-                             'with<htmlspecialchars\n')
-        try:
-            f.write(self.filecontents)
-        finally:
-            f.close()
-        self.tree.add('myfilename')
-        self.fileid = self.tree.path2id('myfilename')
-        self.msg = 'a very exciting commit message <'
-        self.revid = self.tree.commit(message=self.msg)
-
-        self.setUpLoggerhead()
-
-    def test_index(self):
-        testutil.create_request('/')
-        link = '<a href="/project/branch">branch</a>'
-        assert link in cherrypy.response.body[0].lower()
-
-    def test_changes(self):
-        testutil.create_request('/project/branch/changes')
-        assert cgi.escape(self.msg) in cherrypy.response.body[0]
-
-    def test_changes_search(self):
-        testutil.create_request('/project/branch/changes?q=foo')
-        assert 'Sorry, no results found for your search.' in cherrypy.response.body[0]
-
-    def test_annotate(self):
-        testutil.create_request('/project/branch/annotate?'
-                                + 'file_id='+self.fileid)
-        for line in self.filecontents.splitlines():
-            assert cgi.escape(line) in cherrypy.response.body[0]
-
-    def test_inventory(self):
-        testutil.create_request('/project/branch/files')
-        assert 'myfilename' in cherrypy.response.body[0]
-
-    def test_revision(self):
-        testutil.create_request('/project/branch/revision/' + self.revid)
-        assert 'myfilename' in cherrypy.response.body[0]
-
-class TestWithSimpleTreeAndCache(TestWithSimpleTree):
-    config_template = """
-    testing = True
-    [project]
-        [[branch]]
-            branch_name = 'branch'
-            folder = '%(branch)s'
-            cachepath = '%(branch)s/cache'
-    """
-
-class TestEmptyBranch(BasicTests):
-
-    def setUp(self):
-        BasicTests.setUp(self)
-        self.createBranch()
-        self.setUpLoggerhead()
-
-    def test_index(self):
-        testutil.create_request('/')
-        link = '<a href="/project/branch">branch</a>'
-        assert link in cherrypy.response.body[0].lower()
-
-    def test_changes(self):
-        testutil.create_request('/project/branch/changes')
-        assert 'No revisions!' in cherrypy.response.body[0]
-
-class TestEmptyBranchWithCache(TestEmptyBranch):
-    config_template = """
-    testing = True
-    [project]
-        [[branch]]
-            branch_name = 'branch'
-            folder = '%(branch)s'
-            cachepath = '%(branch)s/cache'
-    """
-

=== modified file 'loggerhead/textindex.py'
--- loggerhead/textindex.py	2008-02-27 03:36:09 +0000
+++ loggerhead/textindex.py	2007-01-02 07:14:03 +0000
@@ -19,19 +19,22 @@
 """
 indexing of the comment text of revisions, for fast searching.
 
-two separate database files are created:
+two separate 'shelve' files are created:
 
     - recorded: revid -> 1 (if the revid is indexed)
     - index: 3-letter substring -> list(revids)
 """
 
+import logging
 import os
 import re
+import shelve
+import threading
 import time
 
 from loggerhead import util
+from loggerhead.util import decorator
 from loggerhead.lockfile import LockFile
-from loggerhead.changecache import FakeShelf
 
 # if any substring index reaches this many revids, replace the entry with
 # an ALL marker -- it's not worth an explicit index.
@@ -62,63 +65,55 @@
     def __init__(self, history, cache_path):
         self.history = history
         self.log = history.log
-
+        
         if not os.path.exists(cache_path):
             os.mkdir(cache_path)
-
-        self._recorded_filename = os.path.join(cache_path, 'textindex-recorded.sql')
-        self._index_filename = os.path.join(cache_path, 'textindex.sql')
-
+        
+        self._recorded_filename = os.path.join(cache_path, 'textindex-recorded')
+        self._index_filename = os.path.join(cache_path, 'textindex')
+        
         # use a lockfile since the cache folder could be shared across different processes.
         self._lock = LockFile(os.path.join(cache_path, 'index-lock'))
         self._closed = False
-
+        
         self.log.info('Using search index; %d entries.', len(self))
-
-    def _index(self):
-        return FakeShelf(self._index_filename)
-
-    def _recorded(self):
-        return FakeShelf(self._recorded_filename)
-
+    
     def _is_indexed(self, revid, recorded):
-        return recorded.get(util.to_utf8(revid)) is not None
-
+        return recorded.get(util.to_utf8(revid), None) is not None
+        
     @with_lock
     def is_indexed(self, revid):
-        recorded = self._recorded()
+        recorded = shelve.open(self._recorded_filename, 'c', protocol=2)
         try:
             return self._is_indexed(revid, recorded)
         finally:
             recorded.close()
-
+    
     @with_lock
     def __len__(self):
-        recorded = self._recorded()
+        recorded = shelve.open(self._recorded_filename, 'c', protocol=2)
         try:
-            return recorded.count()
+            return len(recorded)
         finally:
             recorded.close()
 
     @with_lock
     def close(self):
         self._closed = True
-
+    
     @with_lock
     def closed(self):
         return self._closed
-
+    
     @with_lock
     def flush(self):
         pass
-
+    
     @with_lock
     def full(self):
-        recorded = self._recorded()
-        last_revid = util.to_utf8(self.history.last_revid)
+        recorded = shelve.open(self._recorded_filename, 'c', protocol=2)
         try:
-            return (recorded.count() >= len(self.history.get_revision_history())
-                    and recorded.get(last_revid) is not None)
+            return (len(recorded) >= len(self.history.get_revision_history())) and (util.to_utf8(self.history.last_revid) in recorded)
         finally:
             recorded.close()
 
@@ -131,7 +126,7 @@
             return
         for i in xrange(len(comment) - 2):
             sub = comment[i:i + 3]
-            orig = revid_set = index.get(sub)
+            revid_set = index.get(sub, None)
             if revid_set is None:
                 revid_set = set()
             elif revid_set == ALL:
@@ -140,42 +135,39 @@
             revid_set.add(change.revid)
             if len(revid_set) > ALL_THRESHOLD:
                 revid_set = ALL
-            if orig is not None:
-                index.update([(sub, revid_set)], commit=False)
-            else:
-                index.add([(sub, revid_set)], commit=False)
-
-        recorded.add([(util.to_utf8(change.revid), True)], commit=False)
+            index[sub] = revid_set
+        
+        recorded[util.to_utf8(change.revid)] = True
 
     @with_lock
     def index_changes(self, revid_list):
-        recorded = self._recorded()
-        index = self._index()
+        recorded = shelve.open(self._recorded_filename, 'c', protocol=2)
+        index = shelve.open(self._index_filename, 'c', protocol=2)
         try:
             revid_list = [r for r in revid_list if not self._is_indexed(r, recorded)]
             change_list = self.history.get_changes(revid_list)
             for change in change_list:
                 self._index_change(change, recorded, index)
         finally:
-            index.close(commit=True)
-            recorded.close(commit=True)
-
+            index.close()
+            recorded.close()
+    
     @with_lock
     def find(self, text, revid_list=None):
-        index = self._index()
+        index = shelve.open(self._index_filename, 'c', protocol=2)
         try:
             text = normalize_string(text)
             if len(text) < 3:
                 return []
-
+    
             total_set = None
             if revid_list is not None:
                 total_set = set(revid_list)
             seen_all = False
-
+            
             for i in xrange(len(text) - 2):
                 sub = text[i:i + 3]
-                revid_set = index.get(sub)
+                revid_set = index.get(sub, None)
                 if revid_set is None:
                     # zero matches, stop here.
                     return []
@@ -191,7 +183,7 @@
                     return []
         finally:
             index.close()
-
+        
         # tricky: if seen_all is True, one of the substring indices was ALL
         # (in other words, unindexed), so our results are actually a superset
         # of the exact answer.
@@ -201,7 +193,7 @@
         # we DON'T care, and if one of the substrings hit ALL, there's a small
         # chance that we'll give a few false positives.
         return total_set
-
+    
     def check_rebuild(self, max_time=3600):
         """
         check if there are any un-indexed revisions, and if so, index them.
@@ -238,3 +230,4 @@
             time.sleep(1)
         self.log.info('Search index completed.')
         self.flush()
+

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2008-02-27 03:36:09 +0000
+++ loggerhead/util.py	2007-01-21 00:05:52 +0000
@@ -26,9 +26,10 @@
 import struct
 import sys
 import threading
-import time
 import traceback
 
+import turbogears
+
 
 log = logging.getLogger("loggerhead.controllers")
 
@@ -76,25 +77,6 @@
     return year
 
 
-_g_format = '%Y-%m-%d @ %H:%M'
-
-def format_date(date):
-    if _g_format == 'fancy':
-        return fancy_format_date(date)
-    return date.strftime(_g_format)
-
-def fancy_format_date(date):
-    delta = datetime.datetime.now() - date
-    if delta.days > 300:
-        return date.strftime('%d %b %Y')
-    else:
-        return date.strftime('%d %b %H:%M')
-
-def set_date_format(format):
-    global _g_format
-    _g_format = format
-
-
 class Container (object):
     """
     Convert a dict into an object with attributes.
@@ -105,7 +87,7 @@
                 setattr(self, key, value)
         for key, value in kw.iteritems():
             setattr(self, key, value)
-
+    
     def __repr__(self):
         out = '{ '
         for key, value in self.__dict__.iteritems():
@@ -160,7 +142,7 @@
         return '%s at %s' % (username, domains[-2])
     return '%s at %s' % (username, domains[0])
 
-
+    
 def triple_factors(min_value=1):
     factors = (1, 3)
     index = 0
@@ -178,10 +160,10 @@
     """
     given a position in a maximum range, return a list of negative and positive
     jump factors for an hgweb-style triple-factor geometric scan.
-
+    
     for example, with pos=20 and max=500, the range would be:
     [ -10, -3, -1, 1, 3, 10, 30, 100, 300 ]
-
+    
     i admit this is a very strange way of jumping through revisions.  i didn't
     invent it. :)
     """
@@ -198,7 +180,6 @@
 # only do this if unicode turns out to be a problem
 #_BADCHARS_RE = re.compile(ur'[\u007f-\uffff]')
 
-# FIXME: get rid of this method; use fixed_width() and avoid XML().
 def html_clean(s):
     """
     clean up a string for html display.  expand any tabs, encode any html
@@ -206,31 +187,11 @@
     in displaying monospace text.
     """
     s = cgi.escape(s.expandtabs())
+#    s = _BADCHARS_RE.sub(lambda x: '&#%d;' % (ord(x.group(0)),), s)
     s = s.replace(' ', '&nbsp;')
     return s
 
 
-
-NONBREAKING_SPACE = u'\N{NO-BREAK SPACE}'
-
-def fixed_width(s):
-    """
-    expand tabs and turn spaces into "non-breaking spaces", so browsers won't
-    chop up the string.
-    """
-    if not isinstance(s, unicode):
-        # this kinda sucks.  file contents are just binary data, and no
-        # encoding metadata is stored, so we need to guess.  this is probably
-        # okay for most code, but for people using things like KOI-8, this
-        # will display gibberish.  we have no way of detecting the correct
-        # encoding to use.
-        try:
-            s = s.decode('utf-8')
-        except UnicodeDecodeError:
-            s = s.decode('iso-8859-15')
-    return s.expandtabs().replace(' ', NONBREAKING_SPACE)
-
-
 def fake_permissions(kind, executable):
     # fake up unix-style permissions given only a "kind" and executable bit
     if kind == 'directory':
@@ -289,7 +250,7 @@
         divisor = MEG
     else:
         divisor = KILO
-
+    
     dot = size % divisor
     base = size - dot
     dot = dot * 10 // divisor
@@ -297,7 +258,7 @@
     if dot >= 10:
         base += 1
         dot -= 10
-
+    
     out = str(base)
     if (base < 100) and (dot != 0):
         out += '.%d' % (dot,)
@@ -308,35 +269,34 @@
     elif divisor == GIG:
         out += 'G'
     return out
-
-
-def fill_in_navigation(navigation):
+    
+
+def fill_in_navigation(history, navigation):
     """
     given a navigation block (used by the template for the page header), fill
     in useful calculated values.
     """
-    if navigation.revid in navigation.revid_list: # XXX is this always true?
-        navigation.position = navigation.revid_list.index(navigation.revid)
-    else:
+    navigation.position = history.get_revid_sequence(navigation.revid_list, navigation.revid)
+    if navigation.position is None:
         navigation.position = 0
     navigation.count = len(navigation.revid_list)
     navigation.page_position = navigation.position // navigation.pagesize + 1
     navigation.page_count = (len(navigation.revid_list) + (navigation.pagesize - 1)) // navigation.pagesize
-
+    
     def get_offset(offset):
         if (navigation.position + offset < 0) or (navigation.position + offset > navigation.count - 1):
             return None
         return navigation.revid_list[navigation.position + offset]
-
+    
     navigation.prev_page_revid = get_offset(-1 * navigation.pagesize)
     navigation.next_page_revid = get_offset(1 * navigation.pagesize)
-
+    
     params = { 'file_id': navigation.file_id }
     if getattr(navigation, 'query', None) is not None:
         params['q'] = navigation.query
     else:
         params['start_revid'] = navigation.start_revid
-
+        
     if navigation.prev_page_revid:
         navigation.prev_page_url = navigation.branch.url([ navigation.scan_url, navigation.prev_page_revid ], **get_context(**params))
     if navigation.next_page_revid:
@@ -393,25 +353,6 @@
     return _f
 
 
-@decorator
-def lsprof(f):
-    def _f(*a, **kw):
-        from loggerhead.lsprof import profile
-        import cPickle
-        z = time.time()
-        ret, stats = profile(f, *a, **kw)
-        log.debug('Finished profiled %s in %d msec.' % (f.__name__, int((time.time() - z) * 1000)))
-        stats.sort()
-        stats.freeze()
-        now = time.time()
-        msec = int(now * 1000) % 1000
-        timestr = time.strftime('%Y%m%d%H%M%S', time.localtime(now)) + ('%03d' % msec)
-        filename = f.__name__ + '-' + timestr + '.lsprof'
-        cPickle.dump(stats, open(filename, 'w'), 2)
-        return ret
-    return _f
-
-
 # just thinking out loud here...
 #
 # so, when browsing around, there are 5 pieces of context, most optional:
@@ -449,7 +390,7 @@
     """
     return a context map that may be overriden by specific values passed in,
     but only contains keys from the list of valid context keys.
-
+    
     if 'clear' is set, only the 'remember' context value will be added, and
     all other context will be omitted.
     """

=== modified file 'setup.py'
--- setup.py	2008-02-28 04:34:51 +0000
+++ setup.py	2006-12-23 19:29:05 +0000
@@ -15,20 +15,17 @@
     url=url,
     download_url=download_url,
     license=license,
-    maintainer="Michael Hudson",
-    maintainer_email="michael.hudson@canonical.com",
     
     install_requires = [
         "TurboGears >= 1.0b1",
-# for some reason, distutils can't find bzr.
-#        "bzr >= 0.13",
+        "bzr >= 0.13",
     ],
-    scripts = ["start-loggerhead.py", "stop-loggerhead.py"],
+    scripts = ["start-loggerhead.py"],
     zip_safe=False,
     packages=find_packages(),
     package_data = find_package_data(where='loggerhead',
                                      package='loggerhead'),
-#    data_files = find_package_data(where='loggerhead', package='loggerhead'),
+    data_files = find_package_data(where='loggerhead', package='loggerhead'),
     keywords = [
         'turbogears.app',
     ],

=== modified file 'start-loggerhead.py'
--- start-loggerhead.py	2007-09-04 17:06:03 +0000
+++ start-loggerhead.py	2007-01-16 03:53:02 +0000
@@ -5,28 +5,15 @@
 
 import logging
 import os
-import sys
-from optparse import OptionParser
 
 import turbogears
 import cherrypy
 cherrypy.lowercase_api = True
 
-from loggerhead import daemon, release, util
-
-
-def make_handler(config, filename):
-    roll = config.get('log.roll', 'never')
-    if roll == 'daily':
-        h = logging.handlers.TimedRotatingFileHandler(filename, 'midnight', 0, 100)
-    elif roll == 'weekly':
-        h = logging.handlers.TimedRotatingFileHandler(filename, 'W0', 0, 100)
-    else:
-        h = logging.FileHandler(filename)
-    return h
-
-        
-def setup_logging(home, config, foreground):
+import sys
+
+
+def setup_logging(home, foreground):
     # i hate that stupid logging config format, so just set up logging here.
 
     log_folder = os.path.join(home, 'logs')
@@ -35,7 +22,7 @@
     
     f = logging.Formatter('%(levelname)-.3s [%(asctime)s.%(msecs)03d] %(name)s: %(message)s',
                           '%Y%m%d-%H:%M:%S')
-    debug_log = make_handler(config, os.path.join(log_folder, 'debug.log'))
+    debug_log = logging.FileHandler(os.path.join(log_folder, 'debug.log'))
     debug_log.setLevel(logging.DEBUG)
     debug_log.setFormatter(f)
     if foreground:
@@ -44,7 +31,7 @@
         stdout_log.setFormatter(f)
     f = logging.Formatter('[%(asctime)s.%(msecs)03d] %(message)s',
                           '%Y%m%d-%H:%M:%S')
-    access_log = make_handler(config, os.path.join(log_folder, 'access.log'))
+    access_log = logging.FileHandler(os.path.join(log_folder, 'access.log'))
     access_log.setLevel(logging.INFO)
     access_log.setFormatter(f)
     
@@ -57,73 +44,59 @@
     
 
 
-def main():
-    parser = OptionParser(usage='usage: %prog [options]', version='%prog ' + release.version)
-    parser.add_option('-f', '--foreground', action='store_true', dest='foreground', default=False,
-                      help="run in the foreground; don't daemonize")
-    parser.add_option('-C', '--check', action='store_true', dest='check', default=False,
-                      help="only start if not already running (useful for cron jobs)")
-    options, args = parser.parse_args()
-    if len(args) > 0:
-        parser.error('No filename arguments are used, only options.')
-        
-        
-    home = os.path.realpath(os.path.dirname(__file__))
-    pidfile = os.path.join(home, 'loggerhead.pid')
-    
-    if options.check:
-        if daemon.is_running(pidfile):
-            sys.exit(0)
-        sys.stderr.write('Did not find loggerhead running in %r; restarting...\n' % (pidfile,))
-    
-    # read loggerhead config
-    
-    from configobj import ConfigObj
-    config = ConfigObj(os.path.join(home, 'loggerhead.conf'), encoding='utf-8')
-    extra_path = config.get('bzrpath', None)
-    if extra_path:
-        sys.path.insert(0, extra_path)
-    
-    turbogears.update_config(configfile="dev.cfg", modulename="loggerhead.config")
-    
-    potential_overrides = [ ('server.socket_port', int), ('server.webpath', str), ('server.thread_pool', int) ]
-    for key, keytype in potential_overrides:
-        value = config.get(key, None)
-        if value is not None:
-            value = keytype(value)
-            turbogears.config.update({ key: value })
-    
-    if not options.foreground:
-        sys.stderr.write('\n')
-        sys.stderr.write('Launching loggerhead into the background.\n')
-        sys.stderr.write('PID file: %s\n' % (pidfile,))
-        sys.stderr.write('\n')
-    
-        daemon.daemonize(pidfile, home)
-
-    setup_logging(home, config, foreground=options.foreground)
-        
-    log = logging.getLogger('loggerhead')
-    log.info('Starting up...')
-    
-    from loggerhead.controllers import Root
-    
-    Root = Root(config)
-    
-    # re-index every 6 hours
-    index_freq = config.get('cache_rebuild_frequency', 6 * 3600)
-    turbogears.scheduler.add_interval_task(initialdelay=1, interval=index_freq, action=Root._check_rebuild)
-
-    util.set_date_format(config.get('date_format', 'fancy'))
+foreground = False
+if len(sys.argv) > 1:
+    if sys.argv[1] == '-f':
+        foreground = True
+
+home = os.path.realpath(os.path.dirname(__file__))
+pidfile = os.path.join(home, 'loggerhead.pid')
+
+# read loggerhead config
+
+from configobj import ConfigObj
+config = sys._loggerhead_config = ConfigObj(os.path.join(home, 'loggerhead.conf'), encoding='utf-8')
+extra_path = config.get('bzrpath', None)
+if extra_path:
+    sys.path.insert(0, extra_path)
+
+turbogears.update_config(configfile="dev.cfg", modulename="loggerhead.config")
+
+potential_overrides = [ ('server.socket_port', int), ('server.webpath', str), ('server.thread_pool', int) ]
+for key, keytype in potential_overrides:
+    value = config.get(key, None)
+    if value is not None:
+        value = keytype(value)
+        turbogears.config.update({ key: value })
+
+if not foreground:
+    sys.stderr.write('\n')
+    sys.stderr.write('Launching loggerhead into the background.\n')
+    sys.stderr.write('PID file: %s\n' % (pidfile,))
+    sys.stderr.write('\n')
+
+    from loggerhead.daemon import daemonize
+    daemonize(pidfile, home)
+
+setup_logging(home, foreground=foreground)
+    
+log = logging.getLogger('loggerhead')
+log.info('Starting up...')
+
+from loggerhead.controllers import Root
+
+# re-index every 6 hours
+
+index_freq = config.get('cache_rebuild_frequency', 6 * 3600)
+turbogears.scheduler.add_interval_task(initialdelay=1, interval=index_freq, action=Root._check_rebuild)
+
+try:
+    turbogears.start_server(Root)
+finally:
+    log.info('Shutdown.')
     try:
-        turbogears.start_server(Root)
-    finally:
-        log.info('Shutdown.')
-        try:
-            os.remove(pidfile)
-        except OSError:
-            pass
-
-
-if __name__ == '__main__':
-    main()
+        os.remove(pidfile)
+    except OSError:
+        pass
+
+

